/* Copyright 2006, freshmowed software.  All rights reserved. */

var CANVAS_WIDTH = 200;
var CANVAS_HEIGHT = 104;
var CHART_HEIGHT = 84;
var HEIGHT = 158;
var BACKSIDE_HEIGHT = 350;
var numberRegExp = /^[-]?([0-9]{1}[0-9]{0,}(\.[0-9]{0,2})?|0(\.[0-9]{0,2})?|\.[0-9]{1,2})$/;
var DEFAULT_TITLE = "Countabout";
var DEFAULT_UNITS = "times";
var widgetType = "countabout";
var leftSideIsOpen = false;
var rightSideIsOpen = false;
var bottomIsOpen = false;
var pendingLeftSideToggle = false;
var pendingRightSideToggle = false;
var LEFT_TRAY_WIDTH = 208;
var RIGHT_TRAY_WIDTH = 102;
var CENTER_PANEL_WIDTH = 225;
var CENTER_PANEL_HEIGHT = 130;
var BOTTOM_TRAY_HEIGHT = 53;
var END_WIDTH = 20;
var upgradeDisabled = false;
var upgradeDisabledLatch = false;
var selectedScaleKey = SCALE_1_WEEK_KEY;
var chartScrollArea, chartScrollbar;
var scrollTo = null;
var barChart = null;
var countaboutData = null;
var dataSetInfo = null;
var deleteButtons = null;
var newSelectedDataSetID = null;
var dataSetSelectedForDeletion = null;
var currentTabName = "front";
var dataSetsShown = false;
var settingsShown = true;
var selectedTrackerIndex = 0;
var selectedSettingIndex = 0;
var todaysDate = null;
var currentXValue = null;
var fadeElement = null;
var showingFront = true;
var showingFrontDialog = false;
var showingDialog = false;
var queuedDialog = new Array();
var dialogTitle = null;
var dialogText1 = null;
var dialogText2 = null;
var currentDialogConfig = null;
var queuedDialogs = new Array();
var oldOverlayContentsDiv = null;
var oldRegistrationContentsDiv = null;
var countaboutStyle = null;
var styleKeys = null;
var titles = new Array("Countabout", "Countabout Two", "Countabout Three");
var settingTitles = new Array("Countabout", "Countabout Two", "Countabout Three");
var scaleElements = new Array(SCALE_1_WEEK_KEY, SCALE_MTD_KEY, SCALE_1_MONTH_KEY, SCALE_3_MONTH_KEY, SCALE_YTD_KEY, SCALE_6_MONTH_KEY, SCALE_1_YEAR_KEY, SCALE_AUTO_KEY);
var statsAll = new Array("statAvg", "statMedian", "statMin", "statMax", "statDiff", "statTotal", "statTarget");

function setWidgetType(aWidgetType)
{
    widgetType = aWidgetType;
    
    if ( widgetType == "countabit"  && window.widget != null ) widget.setPreferenceForKey("countabit", createkey("dataSetID"));
}

function getWidgetType()
{
    return widgetType;
}

function getVersionString()
{
    return getVersionMajorNumber() + "." + getVersionMinorNumber() + 
    (getVersionMicroNumber() ? "." + getVersionMicroNumber() : "");
}

//! cannot be null
function getVersionMajorNumber()
{
    return 1;
}

//! cannot be null
function getVersionMinorNumber()
{
    return 1;
}

function getVersionMicroNumber()
{
    return 2;
}

function getLocalizedString (key)
{
    try
    {
        var ret = localizedStrings[key];
        if (ret === undefined) ret = key;
        return ret;
    }
    catch (ex)
    {}
    
    return key;
}


function widgetHeight()
{
    return 130;
}

function widgetWidth()
{
    return 630;
}

function backsideHeight()
{
    return 350;
}

function backsideWidth()
{
    return 265;
}

function fetchData()
{
    var countaboutDataXML = null;
    
    countaboutData = new CountaboutData();
    
    if ( window.widget )
    {
        countaboutDataXML = window.CountaboutPlugin.fetchDataForWidget(dataSetID());
    }
    else
    {
        //alert("using sample data!!!")
        countaboutDataXML = countaboutData.sampleXML();  //! DEBUG ONLY
    }
    
    //alert("xml:" + countaboutDataXML);  
    
    if ( countaboutDataXML == null )
    {
        alert("fetchData: no countaboutDataXML");
        countaboutData.ID = "cbt" + Math.floor(Math.random()*99999);
        countaboutData.trackerData[0] = new TrackerData((widgetType == "countabit" ? "Countabit" : "Countabout"));
        //save();
    }
    else
    {
        //alert("fetchData: countaboutDataXML: " + countaboutDataXML);
        countaboutData.fromXML(countaboutDataXML);
    }
    
    //alert("fetchData: parsed XML (" + countaboutData.trackerData.length + " sets): " + countaboutData.toXML());
    
    return;
}

function fetchDataSetInfo()
{
    var countaboutInfoXML = null;
    
    dataSetInfo = new DataSetInfo();
    
    if ( window.widget )
    {
        countaboutInfoXML = window.CountaboutPlugin.fetchDataSetInfo();
    }
    else
    {
        //alert("using sample data!!!")
        countaboutInfoXML = countaboutInfo.sampleXML();  //! DEBUG ONLY
    }
    
    //alert("dataSetInfo xml:" + countaboutInfoXML);
    
    if ( countaboutInfoXML == null )
    {
        alert("fetchDataSetInfo: no information");
    }
    else
    {
        dataSetInfo.fromXML(countaboutInfoXML);
    }
    
    return;
}

function dataSetID()
{
    if ( !window.widget ) return null;
    
    var anID = widget.preferenceForKey(createkey("dataSetID"));
    
    if ( anID == null || anID == undefined ) anID = widget.identifier;
    
    return anID;
}

function changeDataSetToID(aDataSetID)
{
    if ( aDataSetID == null ) return;
    
    if ( window.widget )
    {
        var currentID = widget.preferenceForKey(createkey("dataSetID"));
        if ( currentID != aDataSetID )
        {
            alert("changeDataSetToID: " + aDataSetID + " from: " + currentID );
            widget.setPreferenceForKey(aDataSetID, createkey("dataSetID"));
            Scale.current.reset();
            fetchAndConfigure();
            refreshDate();
            Scale.current.adjustMinMax(countaboutData.trackerData[selectedTrackerIndex].dataSet.points, selectedTrackerIndex);
            updateDailyTotal();
            updateStatistics();
        }
    }
}

function buildDataSetTable()
{
    var tableWrapperDiv = document.getElementById("dataSetsTableWrapper");
    var tableContentsDiv = document.getElementById("dataSetsTable");
    var newContents = buildDataSetTableContents();
    tableWrapperDiv.replaceChild(newContents, tableContentsDiv);
}

function buildDataSetTableContents()
{
    /*
     <div class="dataSetTableRow" id="dataSetRowOdd">
     <div class="dataSetMain">
     <div class="dataSetMainRadio"><input type="radio" name="dataSetRadio" value="1" checked=""></div>
     <div class="dataSetMainNames">
     <div id="dataSetName1" class="dataSetName">Weight (lbs)</div>
     <div id="dataSetName2" class="dataSetName">Calories (kcal)</div>
     <div id="dataSetName3" class="dataSetName">Exercise (reps)</div>
     </div>
     <div class="dataSetMainButtons"></div>
     </div>
     <div class="dataSetFooter">Date Range: 10/22/2005  - 11/2/2006</div>
     <div class="dataSetIDDiv">ID: 92937927397239</div>
     </div>     
     */
    
    var contentsDiv = document.createElement("div");
    contentsDiv.id = "dataSetsTable";
    
    var trackerDataSets = dataSetInfo.trackerDataSets;
    
    deleteButtons = new Array();
    
    var startDate = "";
    var endDate = "";
    var oddEven = true;
    for ( iDataSet = 0; iDataSet < trackerDataSets.length; iDataSet++ )
    {
        var aTrackerDataSet = trackerDataSets[iDataSet];
        
        var rowDiv = document.createElement("div");
        rowDiv.id = (oddEven == true ? "dataSetRowOdd" : "dataSetRowEven");
        oddEven = !oddEven;
        rowDiv.className = "dataSetTableRow";
        
        var mainDiv = document.createElement("div");
        mainDiv.className = "dataSetMain";
        rowDiv.appendChild(mainDiv);
        
        var mainRadioDiv = document.createElement("div");
        mainRadioDiv.className = "dataSetMainRadio";
        var radioElement = document.createElement("input");
        radioElement.type = "radio";
        radioElement.name = "dataSetRadio";
        radioElement.value = aTrackerDataSet.ID;
		radioElement.onclick = dataSetRadioClicked;
        if ( aTrackerDataSet.ID == dataSetID() ) 
        {
            newSelectedDataSetID = aTrackerDataSet.ID;
            radioElement.checked = "true";
        }
        mainRadioDiv.appendChild(radioElement);
        mainDiv.appendChild(mainRadioDiv);
        
        var mainNamesDiv = document.createElement("div");
        mainNamesDiv.className = "dataSetMainNames";
        
        var minX = 999999;
        var maxX = -999999;
        var numEntries = 0;
        var dataSetTrackers = aTrackerDataSet.trackers;
        for (iName = 0; iName < dataSetTrackers.length; iName++ )
        {
            var aTrackerInfo = dataSetTrackers[iName];
            numEntries += aTrackerInfo.numPoints * 1;
            
            if ( iName == 0 || aTrackerInfo.numPoints > 0 )
            {
                var nameDiv = document.createElement("div");
                nameDiv.className = "dataSetName";
                nameDiv.innerText = aTrackerInfo.title + " (" + aTrackerInfo.units + ")";
                mainNamesDiv.appendChild(nameDiv);
                
                if ( aTrackerInfo.minX < minX )
                {
                    minX = aTrackerInfo.minX;
                    startDate = aTrackerInfo.startDate;
                }

                if ( aTrackerInfo.maxX > maxX )
                {
                    maxX = aTrackerInfo.maxX;
                    endDate = aTrackerInfo.endDate;
                }                
            }
        }
        
        mainDiv.appendChild(mainNamesDiv);
        
        var mainButtonsDiv = document.createElement("div");
        mainButtonsDiv.className = "dataSetMainButtons";
        var deleteButtonDiv = document.createElement("div");
        deleteButtons[aTrackerDataSet.ID] = deleteButtonDiv;
        deleteButtonDiv.className = "dataSetDeleteButton";
        if ( aTrackerDataSet.ID == dataSetID() ) deleteButtonDiv.style.display = "none";
        var theID = aTrackerDataSet.ID;
        createGenericButton(deleteButtonDiv, 'Delete', new Function('theID', "deleteDataSetPrompt('" + theID + "')"), 57);
        mainButtonsDiv.appendChild(deleteButtonDiv);
        var copyButtonDiv = document.createElement("div");
        copyButtonDiv.className = "dataSetCopyButton";
        createGenericButton(copyButtonDiv, ' Copy ', new Function('theID', "copyDataSet('" + theID + "')"), 57);
        mainButtonsDiv.appendChild(copyButtonDiv);
        mainDiv.appendChild(mainButtonsDiv);
        
        var footerDiv = document.createElement("div");
        footerDiv.className = "dataSetFooter";
        var footerDatesDiv = document.createElement("div");
        footerDatesDiv.className = "dataSetFooterDates";
        footerDatesDiv.innerText = startDate + " - " + endDate;
        footerDatesDiv.style.align = "left";
        var footerPointsDiv = document.createElement("div");
        footerPointsDiv.className = "dataSetFooterPoints";
        footerPointsDiv.innerText = numEntries + " entries";
        footerPointsDiv.style.align = "right";
        footerDiv.appendChild(footerDatesDiv);
        footerDiv.appendChild(footerPointsDiv);
        rowDiv.appendChild(footerDiv);
        
        var dataSetIDDiv = document.createElement("div");
        dataSetIDDiv.className = "dataSetIDDiv";
        dataSetIDDiv.innerText = aTrackerDataSet.ID;
        rowDiv.appendChild(dataSetIDDiv);
        
        contentsDiv.appendChild(rowDiv);
    }
    return contentsDiv;
}

function dataSetRadioClicked(event)
{
    var oldDeleteButton = deleteButtons[newSelectedDataSetID];
    if ( oldDeleteButton != null ) oldDeleteButton.style.display = "block";

    newSelectedDataSetID = event.target.value;
    deleteButtons[newSelectedDataSetID].style.display = "none";
}

function newDataSet()
{
    if ( window.widget )
    {
        countaboutData = new CountaboutData();
        countaboutData.trackerData[0] = new TrackerData("New");
        newSelectedDataSetID = "cbt" + Math.floor(Math.random()*99999);
        countaboutData.ID = newSelectedDataSetID;
        changeDataSetToID(newSelectedDataSetID);
        //widget.setPreferenceForKey(newSelectedDataSetID, createkey("dataSetID"));
        window.CountaboutPlugin.saveDataForWidget(countaboutData.toXML(), newSelectedDataSetID);
        
        fetchDataSetInfo();
        buildDataSetTable();
    }
    
}

function deleteDataSetPrompt(anID)
{
    dataSetSelectedForDeletion = anID;
    
    if ( anID == null ) return;
    
    var aDConfig = new DialogConfig();
    aDConfig.messageText = "Are you sure you want to delete this data set?";
    aDConfig.rightButtonLabel = "Yes";
    aDConfig.middleButtonLabel = "No";
    aDConfig.rightCallback = deleteDataSet;
    aDConfig.middleCallback = cancelDataSetDeletion;
    showDialogWithConfig(aDConfig);
}

function deleteDataSet()
{
    if ( window.widget )
    {
        window.CountaboutPlugin.deleteDataForID(dataSetSelectedForDeletion);
        fetchDataSetInfo();
        buildDataSetTable();
    }
}

function cancelDataSetDeletion()
{
    dataSetSelectedForDeletion = null;
}

function copyDataSet(anID)
{
    if ( window.widget )
    {
        window.CountaboutPlugin.copyDataForID(anID);
        fetchDataSetInfo();
        buildDataSetTable();
    }
}

function getSelectedScaleKey()
{
    return selectedScaleKey;
}

function getSelectedScaleXMin()
{
    return barChart.currentMinX;
}

function getSelectedScaleXMax()
{
    return barChart.currentMaxX;
}

function getTodaysXValue()
{
    return Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(0));
}

function dailyTotal()
{
    var convertedDate = Utilities.numDaysSinceEpoch();
    var pointForDate = countaboutData.trackerData[selectedTrackerIndex].dataSet.pointForX(convertedDate);
    
    return valueStringForPoint(pointForDate);
}

function valueStringForPoint(aPoint)
{
    var valueDescrip = aPoint != null ? aPoint.yDescription : null;
    var value = null;
    if ( valueDescrip != null )
    {
        value = valueDescrip;
    }
    else
    {
        value = aPoint != null ? aPoint.yValue : null;
        
        if ( value == null || isNaN(value) )
            value = "";
        else if ( countaboutData.trackerData[selectedTrackerIndex].units &&
                 countaboutData.trackerData[selectedTrackerIndex].units.indexOf("$") >= 0 )
            value = parseFloat(value).toFixed(2);
        else
            value = Utilities.toFixedStripped(parseFloat(value), 2);
    }
    
    return value;
}

function save()
{
    if ( window.widget )
        window.CountaboutPlugin.saveDataForWidget(countaboutData.toXML(), dataSetID());
}

function showBack(event)
{
    
    var noDataDiv = document.getElementById("noDataDiv");
    var front = document.getElementById("outerContainer");
    var back = document.getElementById("back");
    
    if (window.widget)
    {
        window.resizeTo(widgetWidth(), BACKSIDE_HEIGHT);
        widget.prepareForTransition("ToBack");
    }
    
    if ( noDataDiv ) noDataDiv.style.display = "none";
    back.style.display = "block";
    front.style.display = "none";
    
    showingFront = false;
    
    showSettings();
    
    if (window.widget)
        setTimeout('widget.performTransition();', 0);
    
    window.resizeTo(backsideWidth() + "px", backsideHeight() + "px");
    
    document.getElementById('fliprollie').style.display = 'none';
    
    selectedSettingIndex = selectedTrackerIndex;
    refreshSettingPanel();
    
    event.stopPropagation();
    event.preventDefault();
}

function tabSelectionWillChangeTo(newTabName)
{
    if ( newTabName == "data" && getWidgetType() == "countabit")
    {
      var aDConfig = new DialogConfig();
      aDConfig.messageText = "Feature Not Available";
      aDConfig.messageText2 = "Upgrade to Countabout for this capability.";
      aDConfig.rightButtonLabel = "OK";

      showDialogWithConfig(aDConfig);
      
      return;
    }

    if ( currentTabName == "settings" )
    {
        if ( !leaveSettingsPanel() ) return false;
    }
    else if ( currentTabName == "data" )
    {
        if ( !leaveDataSetsPanel() ) return;
    }
    
    currentTabName = newTabName;
    return true;
}

function showSettings()
{
    if ( !tabSelectionWillChangeTo("settings") ) return;
    
    document.getElementById('settings').style.display="block";
    document.getElementById('dataSets').style.display="none";
    document.getElementById('help').style.display="none";
    document.getElementById('registration').style.display="none";
    document.getElementById('backTabSettings').style.background = "rgb(100,100,100)";
    document.getElementById('backTabSettings').style.border = "1px solid rgb(200,200,200)";
    document.getElementById('backTabStyles').style.background = "rgb(0,0,0)";
    document.getElementById('backTabStyles').style.border = "1px solid rgb(100,100,100)";
    document.getElementById('backTabHelp').style.background = "rgb(0,0,0)";
    document.getElementById('backTabHelp').style.border = "1px solid rgb(100,100,100)";
    document.getElementById('backTabRegister').style.background = "rgb(0,0,0)";
    document.getElementById('backTabRegister').style.border = "1px solid rgb(100,100,100)";
}

function showStyles()
{
    if ( !tabSelectionWillChangeTo("styles") ) return;
    
    document.getElementById('settings').style.display="none";
    document.getElementById('dataSets').style.display="block";
    document.getElementById('help').style.display="none";
    document.getElementById('registration').style.display="none";
    document.getElementById('backTabSettings').style.background = "rgb(0,0,0)";
    document.getElementById('backTabSettings').style.border = "1px solid rgb(100,100,100)";
    document.getElementById('backTabStyles').style.background = "rgb(100,100,100)";
    document.getElementById('backTabStyles').style.border = "1px solid rgb(200,200,200)";
    document.getElementById('backTabHelp').style.background = "rgb(0,0,0)";
    document.getElementById('backTabHelp').style.border = "1px solid rgb(100,100,100)";
    document.getElementById('backTabRegister').style.background = "rgb(0,0,0)";
    document.getElementById('backTabRegister').style.border = "1px solid rgb(100,100,100)";
}

function showDataSets()
{
    if ( !tabSelectionWillChangeTo("data") ) return;
    
    settingsShown = false;
    dataSetsShown = true;
    
    document.getElementById('settings').style.display="none";
    document.getElementById('help').style.display="none";
    document.getElementById('registration').style.display="none";
    document.getElementById('backTabSettings').style.background = "rgb(0,0,0)";
    document.getElementById('backTabSettings').style.border = "1px solid rgb(100,100,100)";
    document.getElementById('backTabStyles').style.background = "rgb(100,100,100)";
    document.getElementById('backTabStyles').style.border = "1px solid rgb(200,200,200)";
    document.getElementById('backTabHelp').style.background = "rgb(0,0,0)";
    document.getElementById('backTabHelp').style.border = "1px solid rgb(100,100,100)";
    document.getElementById('backTabRegister').style.background = "rgb(0,0,0)";
    document.getElementById('backTabRegister').style.border = "1px solid rgb(100,100,100)";
    
    fetchDataSetInfo();
    buildDataSetTable();
    
    document.getElementById('dataSets').style.display="block";
}

function showHelp()
{
    document.getElementById('settings').style.display="none";
    document.getElementById('dataSets').style.display="none";
    document.getElementById('help').style.display="block";
    document.getElementById('registration').style.display="none";
    document.getElementById('backTabStyles').style.background = "rgb(0,0,0)"
    document.getElementById('backTabStyles').style.border = "1px solid rgb(100,100,100)";
    document.getElementById('backTabHelp').style.background = "rgb(100,100,100)";
    document.getElementById('backTabHelp').style.border = "1px solid rgb(200,200,200)";
    document.getElementById('backTabSettings').style.background = "rgb(0,0,0)";
    document.getElementById('backTabSettings').style.border = "1px solid rgb(100,100,100)";
    document.getElementById('backTabRegister').style.background = "rgb(0,0,0)";
    document.getElementById('backTabRegister').style.border = "1px solid rgb(100,100,100)";
}

function showRegistration()
{
    var isLicensed = false;
    var serialNumber = "<none>";
    var enablementDescription = "";
    if ( window.widget ) 
    {
        isLicensed = window.CountaboutPlugin.isLicensed();
        serialNumber = window.CountaboutPlugin.serialNumber();
        enablementDescription = window.CountaboutPlugin.enablementDescription();
        document.getElementById("enablementDescription").innerText = enablementDescription;
        document.getElementById("serialNumberDiv").innerText = serialNumber;
    }
    
    if ( isLicensed )
    {
        document.getElementById('isLicensedDiv').style.display="block";
        document.getElementById('isNotLicensedDiv').style.display="none";
    }
    else
    {
        document.getElementById('isNotLicensedDiv').style.display="block";
        document.getElementById('isLicensedDiv').style.display="none";
    }
    
    document.getElementById('settings').style.display="none";
    document.getElementById('dataSets').style.display="none";
    document.getElementById('help').style.display="none";
    document.getElementById('registration').style.display="block";
    document.getElementById('backTabRegister').style.background = "rgb(100,100,100)"
    document.getElementById('backTabRegister').style.border = "1px solid rgb(200,200,200)";
    document.getElementById('backTabStyles').style.background = "rgb(0,0,0)";
    document.getElementById('backTabStyles').style.border = "1px solid rgb(100,100,100)";
    document.getElementById('backTabHelp').style.background = "rgb(0,0,0)";
    document.getElementById('backTabHelp').style.border = "1px solid rgb(100,100,100)";
    document.getElementById('backTabSettings').style.background = "rgb(0,0,0)";
    document.getElementById('backTabSettings').style.border = "1px solid rgb(100,100,100)";
}

function leaveSettingsPanel()
{    
    var newTitle = document.getElementById('titleLabelField').value;
    var select = document.getElementById('titlePopupMenu');
    
    var newGoal = document.getElementById('usersGoalField').value;
    if ( isNaN(newGoal) )
    {
        showDialog("", "Please enter a numerical value for graph target line (or leave blank).", "", null);
        document.getElementById('usersGoalField').value = countaboutData.trackerData[selectedSettingIndex].chart.goal;
        return false;
    }
    
    var newYMin = document.getElementById('usersYMinField').value;
    if ( isNaN(newYMin) )
    {
        showDialog("", "Please enter a numerical value for graph minimum, or leave blank (default is zero).", "", null);
        document.getElementById('usersYMinField').value = countaboutData.trackerData[selectedSettingIndex].chart.yMin;
        return false;
    }
    
    var newUnits = document.getElementById('usersUnitsField').value;
    var newPrefixUnits = document.getElementById('prefixUnits').checked;
    var newEnabled = true; // document.getElementById('enabledCB').checked;
    
    var statsEnabled = new Array();
    for ( i = 0; i < statsAll.length; i++ )
    {
        if ( document.getElementById(statsAll[i] + "CB").checked )
            statsEnabled.push(statsAll[i]);
    }
    
    if ( statsEnabled.length < 1 )
    {
        showDialog("", "Please select at least", "one statistic to display.", null);
        return false;
    }
    
    if ( statsEnabled.length > 6 )
    {
        showDialog("", "Please select no more than", "6 statistics to display.", null);
        return false;
    }
    
    if ( newTitle.indexOf(']]>') != -1 )
    {
        showDialog("", "Illegal Title");
        return false;
    }
    
    if ( newUnits.indexOf(']]>') != -1 )
    {
        showDialog("", "Illegal Units");
        return false;
    }
    
    var chartTypeForm = document.getElementById("chartTypeForm");
    for ( i = 0; i < chartTypeForm.chartTypeRadio.length; i++)
    {
        if ( chartTypeForm.chartTypeRadio[i].checked == true)
        {
            countaboutData.trackerData[selectedSettingIndex].chart.type = chartTypeForm.chartTypeRadio[i].value;
            break;
        }
    }
    
    countaboutData.trackerData[selectedSettingIndex].title = newTitle;
    titles[selectedSettingIndex] = newTitle;
    countaboutData.trackerData[selectedSettingIndex].enabled = newEnabled;
    countaboutData.trackerData[selectedSettingIndex].units = (newUnits == null) ? "" : newUnits;
    countaboutData.trackerData[selectedSettingIndex].prefixUnits = newPrefixUnits;
    countaboutData.trackerData[selectedSettingIndex].chart.goal = newGoal == null || newGoal.length == 0 ? null : parseFloat(newGoal);
    countaboutData.trackerData[selectedSettingIndex].chart.yMin = newYMin == null || newYMin.length == 0 ? null : parseFloat(newYMin);
    countaboutData.trackerData[selectedSettingIndex].statsEnabled = new Array();
    for ( i = 0; i < statsEnabled.length; i++)
        countaboutData.trackerData[selectedSettingIndex].statsEnabled.push(statsEnabled[i]);
    
    if ( window.widget )
    {
        saveToID = widget.preferenceForKey(createkey("dataSetID"));
		if ( saveToID != null )
        	window.CountaboutPlugin.saveDataForWidget(countaboutData.toXML(), saveToID);
    }
    
    // The selected settings might not be the same as the selected tracker, but it could have changed, so reload
    setTitle(titles[selectedTrackerIndex]);
    for ( i = 0; i < countaboutData.trackerData.length; i++ )
    {
        titles[i] = countaboutData.trackerData[i].title;
        select.options[i].innerText = countaboutData.trackerData[i].title;
        document.getElementById("settingSelectionPopupMenu").options[i].innerText = countaboutData.trackerData[i].title;
        if ( i == selectedSettingIndex ) document.getElementById('settingSelectionTitle').innerText = countaboutData.trackerData[i].title;
    }
    //barChart.setChartConfig(countaboutData.trackerData[selectedTrackerIndex].chart, selectedTrackerIndex);
    document.getElementById("unitsLabel").innerText = countaboutData.trackerData[selectedTrackerIndex].units; 
    barChart.setUnitsString(countaboutData.trackerData[selectedTrackerIndex].units, countaboutData.trackerData[selectedTrackerIndex].prefixUnits);
    
    return true;
}

function leaveDataSetsPanel()
{
    var currentID = widget.preferenceForKey(createkey("dataSetID"));
    
    if ( currentID != newSelectedDataSetID )
    {
        changeDataSetToID(newSelectedDataSetID);
    }
    
    return true;
}

function showFront()
{
    if ( !tabSelectionWillChangeTo("front") ) return;
    
    var front = document.getElementById("outerContainer");
    var back = document.getElementById("back");
    
    if (window.widget)
        widget.prepareForTransition("ToFront");
    
    front.style.display="block";
    back.style.display="none";
    
    showingFront = true;
    
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
    
    positionUnits();
    
    window.resizeTo(widgetWidth() + "px", widgetHeight() + "px");
    
    scrollTo = "right";
    drawBarChart();
    updateStatistics();
    focusAndSelect();
    
    trackerSelectionChanged();
}

function setTitles(title1, title2, title3)
{
  	var select = document.getElementById('titlePopupMenu');
    while (select.options.length > 0) 
    {
        select.options[0] = null;
    }
    
    if ( title1 != null && title1 != "")
    {
        var element = document.createElement("option");
        element.innerText = title1;
        select.appendChild(element);
        titles[0] = title1;
        if ( selectedTrackerIndex == 0 ) setTitle(title1);
        //countaboutData.trackerData[0].title = title1;
    }
    
    if ( title2 != null && title2 != "")
    {
        var element = document.createElement("option");
        element.innerText = title2;
        select.appendChild(element);
        titles[1] = title2;
        if ( selectedTrackerIndex == 1 ) setTitle(title2);
        //countaboutData.trackerData[1].title = title2;
    }
    
    if ( title3 != null && title3 != "")
    {
        var element = document.createElement("option");
        element.innerText = title3;
        select.appendChild(element);
        titles[2] = title2;
        if ( selectedTrackerIndex == 2 ) setTitle(title3);
        //countaboutData.trackerData[2].title = title3;
    }
    
    select.selectedIndex = selectedTrackerIndex;
    setTitle(titles[selectedTrackerIndex]);
}

function setTitle(aTitle)
{
    document.getElementById("titlePopupLabel" + (selectedTrackerIndex+1)).innerText = aTitle;
}

function populateTitleSelect()
{
  	var select = document.getElementById('titlePopupMenu');
    while (select.options.length > 0) 
    {
        select.options[0] = null;
    }
    
    for ( var i = 0; i < countaboutData.trackerData.length; ++i )
    {
        var element = document.createElement("option");
        element.innerText = countaboutData.trackerData[i].title;
        select.appendChild(element);
        titles[i] = countaboutData.trackerData[i].title;
    }
    select.selectedIndex = 0;
    setTitle(titles[selectedTrackerIndex]);
}

function populateSettingSelection()
{
  	var select = document.getElementById('settingSelectionPopupMenu');
    while (select.options.length > 0) 
    {
        select.options[0] = null;
    }
    
    for ( var i = 0; i < settingTitles.length; ++i )
    {
        var element = document.createElement("option");
        element.innerText = settingTitles[i];
        select.appendChild(element);
    }
}

function populateStyleSelect()
{
  	var select = document.getElementById('styleSelectionPopupMenu');
    while (select.options.length > 0) 
    {
        select.options[0] = null;
    }
    
    for ( var i = 0; i < styleKeys.length; ++i )
    {
        var element = document.createElement("option");
        element.innerText = styleKeys[i];
        select.appendChild(element);
        
        if ( styleKeys[i] == countaboutStyle.key ) select.selectedIndex = i;
    }
}

function getStyleKeys()
{
    styleKeys = null;
    if ( window.widget )
    {
        var styleKeysString = window.CountaboutPlugin.availableStyles();
        styleKeys = (styleKeysString ? styleKeysString.split(",") : null);
    }
    
    if ( styleKeys == null ) styleKeys = new Array("default");    
}

function isStyleKey(aKey)
{
    getStyleKeys();
    
    if (styleKeys == null || styleKeys.length == 0 ) return false;
    
    var iSt;
    for ( iSt = 0; iSt < styleKeys.length; iSt++ )
    {
        if ( styleKeys[iSt] == aKey ) return true;
    }
    
    return false;
}

function populateScaleSelect()
{
  	var select = document.getElementById('scalePopupMenu');
    while (select.options.length > 0) 
    {
        select.options[0] = null;
    }
    
    for ( var i = 0; i < scaleElements.length; ++i )
    {
        var element = document.createElement("option");
        element.innerText = Scale.directory[scaleElements[i]].label;
        select.appendChild(element);
        
        if ( scaleElements[i] == selectedScaleKey ) select.selectedIndex = i;
    }
    
    document.getElementById("scalePopupLabel").innerText = Scale.directory[selectedScaleKey].label;
}

function changeScale(select)
{
    selectedScaleKey = scaleElements[select.selectedIndex];
    
    if ( window.widget) widget.setPreferenceForKey(selectedScaleKey, createkey("scale"));
    
    document.getElementById("scalePopupLabel").innerText = Scale.directory[selectedScaleKey].label;
    document.getElementById("chartNote").innerText = "";
	document.getElementById('pencil').style.display = "none";
    Scale.current = Scale.directory[selectedScaleKey];
    Scale.current.adjustMinMax(countaboutData.trackerData[selectedTrackerIndex].dataSet.points, selectedTrackerIndex);
    
    updateStatistics();
    barChart.setNeedsRefresh(true);
    scrollTo = "right";
    drawBarChart();
    
    focusAndSelect();
}

function changeSelectedTracker(select)
{
    if ( selectedTrackerIndex == select.selectedIndex ) return;
    
    selectedTrackerIndex = select.selectedIndex;
    
    trackerSelectionChanged();
}

function changeSelectedTrackerToIndex(anIndex, event)
{
    if ( anIndex < 0 || anIndex > 2 ) return;
    
    selectedTrackerIndex = anIndex;
    document.getElementById("titlePopupMenu").selectedIndex = selectedTrackerIndex;
    trackerSelectionChanged();
    
    var inputString = null;
    if ( event.target.id == "dateField" )
        inputString = dateField().value;
    else if ( event.target.id == "yValueField" )
        inputString = yValueField().value;
    
    if ( event.target.id == "dateField" )
        dateField().value = inputString;
    else if ( event.target.id == "yValueField" )
        yValueField().value = inputString;
    
}

function trackerSelectionChanged()
{
    setTitle(titles[selectedTrackerIndex]);
    
    for ( iST = 0; iST < 3; iST++ )
    {
        var suffix = iST + 1;
        document.getElementById("titlePopupLabel" + suffix).style.display = (iST == selectedTrackerIndex) ? "block" : "none";
    }
    
    if ( countaboutData.trackerData[selectedTrackerIndex].units == "null") countaboutData.trackerData[selectedTrackerIndex].units = "";
    
    document.getElementById("unitsLabel").innerText = countaboutData.trackerData[selectedTrackerIndex].units;
    document.getElementById("modeIcon-img").src = countaboutData.trackerData[selectedTrackerIndex].additionMode == "add" ? "styles/" + countaboutStyle.key + "/images/plusSignButton.png" : "styles/" + countaboutStyle.key + "/images/equalSignButton.png";
    document.getElementById("chartNote").innerText = "";
    document.getElementById('pencil').style.display = "none";
    
    for ( tIndex = 0; tIndex < 3; tIndex++)
    {
        if ( tIndex == selectedTrackerIndex )
            document.getElementById("bullet" + tIndex).src = "images/bulletSolid.png";
        else if ( countaboutData.trackerData[tIndex].chart.enabled )
            document.getElementById("bullet" + tIndex).src = "images/bulletFilled33Pct.png";
        else
            document.getElementById("bullet" + tIndex).src = "images/bullet33Pct.png";
    }
    
    barChart.primaryIndex = selectedTrackerIndex;
    barChart.setUnitsString(countaboutData.trackerData[selectedTrackerIndex].units, countaboutData.trackerData[selectedTrackerIndex].prefixUnits);
    //barChart.setChartConfig(countaboutData.trackerData[selectedTrackerIndex].chart, selectedTrackerIndex);
    barChart.setData(countaboutData.trackerData[selectedTrackerIndex].dataSet.points, selectedTrackerIndex);
    drawBarChart();
    positionUnits();
    updateStatistics();
    updateDailyTotal();
    yValueField().value = "";
    chartScrollArea.refresh();
    focusAndSelect();
}

function changeSelectedSettings(select)
{
    if ( selectedSettingIndex == select.selectedIndex ) return;
    
    var newTitle = document.getElementById('titleLabelField').value;
    
    var newGoal = document.getElementById('usersGoalField').value;
    if ( isNaN(newGoal) )
    {
        showDialog("", "Please enter a numerical value for graph target line (or leave blank).", "", null);
        select.selectedIndex = selectedSettingIndex;
        return;
    }
    
    var newYMin = document.getElementById('usersYMinField').value;
    if ( isNaN(newYMin) )
    {
        showDialog("", "Please enter a numerical value for graph minimum, or leave blank (default is zero).", "", null);
        select.selectedIndex = selectedSettingIndex;
        return;
    }
    
    var newUnits = document.getElementById('usersUnitsField').value;
    var newPrefixUnits = document.getElementById('prefixUnits').checked;
    
    statsEnabled = new Array();
    for ( i = 0; i < statsAll.length; i++ )
    {
        if ( document.getElementById(statsAll[i] + "CB").checked )
            statsEnabled.push(statsAll[i]);
    }
    
    if ( statsEnabled.length < 1 )
    {
        showDialog("", "Please select at least", "one statistic to display.", null);
        select.selectedIndex = selectedSettingIndex;
        return;
    }
    
    if ( statsEnabled.length > 6 )
    {
        showDialog("", "Please select no more than", "6 statistics to display.", null);
        select.selectedIndex = selectedSettingIndex;
        return;
    }
    
    var chartTypeForm = document.getElementById("chartTypeForm");
    for ( i = 0; i < chartTypeForm.chartTypeRadio.length; i++)
    {
        if ( chartTypeForm.chartTypeRadio[i].checked == true)
        {
            countaboutData.trackerData[selectedSettingIndex].chart.type = chartTypeForm.chartTypeRadio[i].value;
            break;
        }
    }
    
    countaboutData.trackerData[selectedSettingIndex].title = newTitle;
    countaboutData.trackerData[selectedSettingIndex].units = newUnits;
    countaboutData.trackerData[selectedSettingIndex].prefixUnits = newPrefixUnits;
    
    var aGoal = newGoal != null ? parseFloat(newGoal) : null;
    if ( aGoal != null && isNaN(aGoal) )  aGoal = null;
    countaboutData.trackerData[selectedSettingIndex].chart.goal = aGoal;
    
    var aYMin = newYMin != null ? parseFloat(newYMin) : null;
    if ( aYMin != null && isNaN(aYMin) )  aYMin = null;
    countaboutData.trackerData[selectedSettingIndex].chart.yMin = aYMin;
    save();
    
    selectedSettingIndex = select.selectedIndex;
    
    document.getElementById("settingSelectionTitle").innerText = settingTitles[select.selectedIndex];
    document.getElementById("settingSelectionTitle").style.background = "url('images/settingDropdown.png') no-repeat";
    refreshSettingPanel();
}

function refreshSettingPanel()
{
    document.getElementById('titleLabelField').value = countaboutData.trackerData[selectedSettingIndex].title;
    document.getElementById('usersGoalField').value = countaboutData.trackerData[selectedSettingIndex].chart.goal;
    document.getElementById('usersYMinField').value = countaboutData.trackerData[selectedSettingIndex].chart.yMin;
    document.getElementById('usersUnitsField').value = countaboutData.trackerData[selectedSettingIndex].units;
    document.getElementById('prefixUnits').checked = countaboutData.trackerData[selectedSettingIndex].prefixUnits;
    
    var chartTypeForm = document.getElementById("chartTypeForm");
    for ( i = 0; i < chartTypeForm.chartTypeRadio.length; i++)
    {
        if ( chartTypeForm.chartTypeRadio[i].value == countaboutData.trackerData[selectedSettingIndex].chart.type)
        {
            chartTypeForm.chartTypeRadio[i].checked = true;
            break;
        }
    }
    
    var stringedArray = countaboutData.trackerData[selectedSettingIndex].statsEnabled.join();
    for ( i = 0; i < statsAll.length; i++ )
    {
        document.getElementById(statsAll[i] + "CB").checked = stringedArray.indexOf(statsAll[i]) != -1;
    }
    
    document.getElementById("settingSelectionPopupMenu").options[selectedSettingIndex].innerText = countaboutData.trackerData[selectedSettingIndex].title;
    document.getElementById("settingSelectionPopupMenu").selectedIndex = selectedSettingIndex;
    document.getElementById('settingSelectionTitle').innerText = countaboutData.trackerData[selectedSettingIndex].title;
}

function drawBarChart()
{
    if ( leftSideIsOpen )
    {
        barChart.getReady();
        chartScrollArea.refresh();
        setTimeout("delayedDraw()", 50);
    }
}

function delayedDraw()
{
    barChart.draw();
    var newBarChartWidth = barChart.width + 'px';
    document.getElementById("canvasAndOverlay").style.width = newBarChartWidth;  //! required!
    chartScrollArea.refresh();
    
    var overlayDivContents = barChart.getOverlayDivContents();
    if ( oldOverlayContentsDiv )
        document.getElementById("overlayDiv").replaceChild(overlayDivContents, oldOverlayContentsDiv);
    else
        document.getElementById("overlayDiv").appendChild(overlayDivContents);
    
    oldOverlayContentsDiv = overlayDivContents;
    
    chartScrollArea.refresh();
    if ( scrollTo == "right")
        scrollToXValue(barChart.currentMaxX);
    else if ( scrollTo == "left")
        scrollToXValue(barChart.currentMinX);
    
}

function expandFinishedLeft()
{
    pendingLeftSideToggle = false;
    
    if ( leftSideIsOpen ) 
    {
        document.getElementById("canvaswrapper").style.display = "block";
        document.getElementById("chartScrollbar").style.display = "block";
        document.getElementById("bulletTray").style.display = "block";
        document.getElementById("bullet" + selectedTrackerIndex).src = "images/bulletSolid.png";
        document.getElementById("chartNote").style.display = "block";
        document.getElementById("chartNote").innerText = "";
        document.getElementById('pencil').style.display = "none";
        barChart.setNeedsRefresh(true);
        drawBarChart();
        
        setTimeout("scrollToXValue();", 100);
    }
    else
    {
        document.getElementById("chartScrollbar").style.display = "none";
        document.getElementById("canvaswrapper").style.display = "none";
        document.getElementById("bulletTray").style.display = "none";
        document.getElementById("chartNote").style.display = "none";
        document.getElementById("chartNote").innerText = "";
    }
    
    if ( pendingRightSideToggle )
    {
        toggleRightTray();
    }
    
    focusAndSelect();
}

function expandFinishedRight()
{
    pendingRightSideToggle = false;
    
    if ( rightSideIsOpen )
    {
        document.getElementById("rightSideContents").style.display = "block";
    }
    else
        document.getElementById("rightSideContents").style.display = "none";
    
    if ( pendingLeftSideToggle )
    {
        toggleLeftTray();
    }
    
    focusAndSelect();
}

function expandFinishedBottom()
{
    
    if ( bottomIsOpen ) 
    {
        document.getElementById("reportButton").style.display = "block";
        document.getElementById("annotateButton").style.display = "block";
        document.getElementById("exportButton").style.display = "block";
    }
    else
    {
        document.getElementById("reportButton").style.display = "none";
        document.getElementById("annotateButton").style.display = "none";
        document.getElementById("exportButton").style.display = "none";
    }
    
    focusAndSelect();
}



var resizeAnimation = { startTime:0, duration:500, positionFrom:0, positionTo:0, positionNow:0, 
frameFrom:0, frameTo:0, frameNow:0, timer:null, element:null, image:null, background:null, onfinished:null};

function animateLeftSide()
{
    var elapsedTime;
    var slope;
    var timeNow     = (new Date).getTime();
    var xLoc;
    
    elapsedTime = Utilities.limit( timeNow - resizeAnimation.startTime, 0, resizeAnimation.duration );
    slope = 0.5 - (0.5 * Math.cos(Math.PI * elapsedTime / resizeAnimation.duration));
    
    if (elapsedTime >= resizeAnimation.duration)    // we're done
    {
        xLoc = resizeAnimation.positionTo;
        clearInterval(resizeAnimation.timer);
        resizeAnimation.timer = null;
        
        if (resizeAnimation.onfinished)
            setTimeout("resizeAnimation.onfinished();", 0);
    }
    else
        xLoc = Utilities.nextValue(resizeAnimation.positionFrom, resizeAnimation.positionTo, slope);
    
    resizeAnimation.positionNow = parseInt(xLoc);
    document.getElementById("leftSide").style.width = resizeAnimation.positionNow + "px";
    document.getElementById("leftSide").style.left = -(resizeAnimation.positionNow) + "px";
    document.getElementById("leftEnd").style.left = -(resizeAnimation.positionNow + END_WIDTH) + "px";
}

function animateRightSide()
{
    var elapsedTime;
    var slope;
    var timeNow     = (new Date).getTime();
    var xLoc;
    
    elapsedTime = Utilities.limit( timeNow - resizeAnimation.startTime, 0, resizeAnimation.duration );
    slope = 0.5 - (0.5 * Math.cos(Math.PI * elapsedTime / resizeAnimation.duration));
    
    if (elapsedTime >= resizeAnimation.duration)    // we're done
    {
        xLoc = resizeAnimation.positionTo;
        clearInterval(resizeAnimation.timer);
        resizeAnimation.timer = null;
        
        if (resizeAnimation.onfinished)
            setTimeout("resizeAnimation.onfinished();", 0);
    }
    else
        xLoc = Utilities.nextValue(resizeAnimation.positionFrom, resizeAnimation.positionTo, slope);
    
    resizeAnimation.positionNow = parseInt(xLoc);
    document.getElementById("rightSide").style.width = resizeAnimation.positionNow + "px";
    document.getElementById("rightEnd").style.left = CENTER_PANEL_WIDTH + resizeAnimation.positionNow + "px";
}

function animateBottom()
{
    var elapsedTime;
    var slope;
    var timeNow = (new Date).getTime();
    var yLoc;
    
    elapsedTime = Utilities.limit( timeNow - resizeAnimation.startTime, 0, resizeAnimation.duration );
    slope = 0.5 - (0.5 * Math.cos(Math.PI * elapsedTime / resizeAnimation.duration));
    
    if (elapsedTime >= resizeAnimation.duration)    // we're done
    {
        yLoc = resizeAnimation.positionTo;
        clearInterval(resizeAnimation.timer);
        resizeAnimation.timer = null;
        
        if (resizeAnimation.onfinished)
            setTimeout("resizeAnimation.onfinished();", 0);
    }
    else
        yLoc = Utilities.nextValue(resizeAnimation.positionFrom, resizeAnimation.positionTo, slope);
    
    resizeAnimation.positionNow = parseInt(yLoc);
    document.getElementById("bottomTray").style.height = resizeAnimation.positionNow + "px";
    document.getElementById("releaseButtonBottom").style.top = -12 + resizeAnimation.positionNow + "px";
}

var fadeAnimation = { startTime:0, duration:500, opacityFrom:0.0, opacityTo:1.0, opacityNow:0.0, 
frameFrom:0, frameTo:0, frameNow:0, timer:null, element:null, image:null, background:null, onfinished:null};


function fadeIn()
{
    if ( fadeElement == null )
    {
        alert("fadeIn:  no 'fadeElement' set.");
        return;
    }
    
    var timeNow = (new Date).getTime();
    var opacity;
    
    var elapsedTime = Utilities.limit( timeNow - fadeAnimation.startTime, 0, fadeAnimation.duration );
    var slope = 0.5 - (0.5 * Math.cos(Math.PI * elapsedTime / fadeAnimation.duration));
    
    if (elapsedTime >= fadeAnimation.duration)    // we're done
    {
        clearInterval(fadeAnimation.timer);
        fadeAnimation.timer = null;
    }
    else
        opacity = Utilities.nextValue(fadeAnimation.opacityFrom, fadeAnimation.opacityTo, slope);
    
    fadeAnimation.opacityNow = opacity;
    fadeElement.style.opacity = fadeAnimation.opacityNow;
}

var fadeOutAnimation = { startTime:0, duration:500, opacityFrom:1.0, opacityTo:0.0, opacityNow:1.0, 
frameFrom:0, frameTo:0, frameNow:0, timer:null, element:null, image:null, background:null, onfinished:null};

function fadeOut()
{
    if ( fadeElement == null )
    {
        alert("fadeOut:  no 'fadeElement' set.");
        return;
    }
    
    var outTimeNow = (new Date).getTime();
    var outOpacity;
    
    var outElapsedTime = Utilities.limit( outTimeNow - fadeOutAnimation.startTime, 0, fadeOutAnimation.duration );
    var outSlope = 0.5 - (0.5 * Math.cos(Math.PI * outElapsedTime / fadeOutAnimation.duration));
    
    if (outElapsedTime >= fadeOutAnimation.duration)    // we're done
    {
        fadeElement.style.display = 'none';
        clearInterval(fadeOutAnimation.timer);
        fadeOutAnimation.timer = null;
        if ( fadeOutAnimation.onfinished != null )
            setTimeout("fadeOutAnimation.onfinished();", 0);
    }
    else
        outOpacity = Utilities.nextValue(fadeOutAnimation.opacityFrom, fadeOutAnimation.opacityTo, outSlope);
    
    fadeOutAnimation.opacityNow = outOpacity;
    fadeElement.style.opacity = fadeOutAnimation.opacityNow;
}


function toggleLeftTray(event)
{
    var multiplier = 1; // (event.shiftKey ? 10 : 1); // enable slo-mo
    var startingWidth, resizeTo;
    
    startingWidth = leftSideIsOpen ? LEFT_TRAY_WIDTH : 0;
    resizeTo = leftSideIsOpen ? 0 : LEFT_TRAY_WIDTH;
    
    leftSideIsOpen = !leftSideIsOpen;
    
    document.getElementById("canvaswrapper").style.display = "none";
    document.getElementById("chartScrollbar").style.display = "none";
    document.getElementById("bulletTray").style.display = "none";
    document.getElementById("chartNote").style.display = "none";
    document.getElementById('pencil').style.display = "none";
    
    var timeNow = (new Date).getTime();
    if (resizeAnimation.timer != null) // it is moving... change to new size
    {
        clearInterval(resizeAnimation.timer);
        resizeAnimation.timer = null;
        resizeAnimation.duration -= (timeNow - resizeAnimation.startTime);
        resizeAnimation.positionFrom = resizeAnimation.positionNow;
    }
    else
    {
        resizeAnimation.duration = 300 * multiplier;
        resizeAnimation.positionFrom = startingWidth;
    }
    
    resizeAnimation.positionTo = parseInt(resizeTo);
    resizeAnimation.startTime = timeNow - 13; // set it back one frame.
    resizeAnimation.onfinished = expandFinishedLeft;
    resizeAnimation.timer = setInterval("animateLeftSide();", 13);
    animateLeftSide();
}

function toggleRightTray(event)
{
    var multiplier = 1; // (event.shiftKey ? 10 : 1); // enable slo-mo
    var startingWidth, resizeTo;
    
    startingWidth = rightSideIsOpen ? RIGHT_TRAY_WIDTH : 0;
    resizeTo = rightSideIsOpen ? 0 : RIGHT_TRAY_WIDTH;
    
    rightSideIsOpen = !rightSideIsOpen;
    
    document.getElementById("rightSideContents").style.display = "none";
    
    var timeNow = (new Date).getTime();
    if (resizeAnimation.timer != null) // it is moving... change to new size
    {
        clearInterval(resizeAnimation.timer);
        resizeAnimation.timer = null;
        resizeAnimation.duration -= (timeNow - resizeAnimation.startTime);
        resizeAnimation.positionFrom = resizeAnimation.positionNow;
    }
    else
    {
        resizeAnimation.duration = 300 * multiplier;
        resizeAnimation.positionFrom = startingWidth;
    }
    
    resizeAnimation.positionTo = parseInt(resizeTo);
    resizeAnimation.startTime = timeNow - 13; // set it back one frame.
    resizeAnimation.onfinished = expandFinishedRight;
    resizeAnimation.timer = setInterval("animateRightSide();", 13);
    animateRightSide();
}

function toggleBottomTray(event)
{
    var multiplier = 1; // (event.shiftKey ? 10 : 1); // enable slo-mo
    var startingHeight, resizeTo;
    
    startingHeight = bottomIsOpen ? BOTTOM_TRAY_HEIGHT : 12;
    resizeTo = bottomIsOpen ? 12 : BOTTOM_TRAY_HEIGHT;
    
    bottomIsOpen = !bottomIsOpen;
    
    //if ( !bottomIsOpen )
    //  document.getElementById("bottomTrayContents").style.display = "none";
    
    var timeNow = (new Date).getTime();
    if (resizeAnimation.timer != null) // it is moving... change to new size
    {
        clearInterval(resizeAnimation.timer);
        resizeAnimation.timer = null;
        resizeAnimation.duration -= (timeNow - resizeAnimation.startTime);
        resizeAnimation.positionFrom = resizeAnimation.positionNow;
    }
    else
    {
        resizeAnimation.duration = 300 * multiplier;
        resizeAnimation.positionFrom = startingHeight;
    }
    
    resizeAnimation.positionTo = parseInt(resizeTo);
    resizeAnimation.startTime = timeNow - 13; // set it back one frame.
    resizeAnimation.onfinished = expandFinishedBottom;
    resizeAnimation.timer = setInterval("animateBottom();", 13);
    animateBottom();
}

function bulletClicked(event)
{
    var imgID = event.target.id;
    var anIndex = ((imgID.charAt(imgID.length-1)) * 1);
    bulletClickedWithIndex(anIndex);
}    

function bulletClickedWithIndex(anIndex)
{  
    if ( anIndex == selectedTrackerIndex ) return;
    
    var isEnabled = countaboutData.trackerData[anIndex].chart.enabled;
    countaboutData.trackerData[anIndex].chart.enabled = !isEnabled;
    if ( countaboutData.trackerData[anIndex].chart.enabled )
        document.getElementById("bullet" + anIndex).src = "images/bulletFilled33Pct.png";
    else
        document.getElementById("bullet" + anIndex).src = "images/bullet33Pct.png";
    
    save();
    barChart.setNeedsRefresh(true);
    drawBarChart();
    focusAndSelect();
}

function toggleMode(event)
{
    if ( countaboutData.trackerData[selectedTrackerIndex].additionMode == "add" )
        countaboutData.trackerData[selectedTrackerIndex].additionMode = "replace";
    else
        countaboutData.trackerData[selectedTrackerIndex].additionMode = "add";
    
    document.getElementById("modeIcon-img").src = countaboutData.trackerData[selectedTrackerIndex].additionMode == "add" ? "styles/" + countaboutStyle.key + "/images/plusSignButton.png" : "styles/" + countaboutStyle.key + "/images/equalSignButton.png";
    save();
    focusAndSelect();
}

function buy()
{
    if ( window.widget ) 
        widget.openURL("http://store.eSellerate.net/s.asp?s=STR7633444026");
}

function register()
{
    if ( window.widget ) 
        widget.openApplication("com.freshmowed.FMLicenseManager");
}

var flipAnimation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};
var flipShown = false;

function flipAnimate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
    
    
    T = Utilities.limit(time-flipAnimation.starttime, 0, flipAnimation.duration);
    
    if (T >= flipAnimation.duration)
    {
        clearInterval (flipAnimation.timer);
        flipAnimation.timer = null;
        flipAnimation.now = flipAnimation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / flipAnimation.duration));
        flipAnimation.now = Utilities.nextValue(flipAnimation.from, flipAnimation.to, ease);
    }
    
    flipAnimation.element.style.opacity = flipAnimation.now;
}

function mousemove(event)
{
    if (!flipShown)
    {
        // fade in the flip widget
        if (flipAnimation.timer != null)
        {
            clearInterval (flipAnimation.timer);
            flipAnimation.timer     = null;
        }
        
        var starttime = (new Date).getTime() - 13; // set it back one frame
        
        flipAnimation.duration = 500;
        flipAnimation.starttime = starttime;
        flipAnimation.element = document.getElementById ('flip');
        flipAnimation.timer = setInterval ("flipAnimate();", 13);
        flipAnimation.from = flipAnimation.now;
        flipAnimation.to = 1.0;
        flipAnimate();
        flipShown = true;
    }
}

function mouseexit(event)
{
    if (flipShown)
    {
        // fade in the flip widget
        if (flipAnimation.timer != null)
        {
            clearInterval (flipAnimation.timer);
            flipAnimation.timer     = null;
        }
        
        var starttime = (new Date).getTime() - 13; // set it back one frame
        
        flipAnimation.duration = 500;
        flipAnimation.starttime = starttime;
        flipAnimation.element = document.getElementById ('flip');
        flipAnimation.timer = setInterval ("flipAnimate();", 13);
        flipAnimation.from = flipAnimation.now;
        flipAnimation.to = 0.0;
        flipAnimate();
        flipShown = false;
    }
}

function dataFieldChanged()
{
    if ( upgradeDisabled ) 
    {
        upgradeDisabledLatch = false;
        showCloseForUpgradeDialog();
        return;
    }
    
    var newYValue;
    var newDateString = dateField().value;
    var newYValueString = yValueField().value;
    //var numberRegExp = /^[-]?([1-9]{1}[0-9]{0,}(\.[0-9]{0,2})?|0(\.[0-9]{0,2})?|\.[0-9]{1,2})$/
    
    if (newDateString == null || 
        newDateString == "" ||
        newYValueString == null || 
        newYValueString == "" ) 
    {
        showDialog("", "Enter a numerical value and date then hit return");
        return;
    }
    
    if ( isStyleKey(newYValueString) )
    {
        applyStyle(newYValueString);
        return;
    }
        
    if ( newYValueString == "bu" )
    {
        if ( window.widget )
        {
            window.CountaboutPlugin.backupDataForID(dataSetID());
            yValueField().value = "OK";
            return;
        }
    }
    
    if ( newYValueString == "rv" || newYValueString == "revert" )
    {
        if ( window.widget )
        {
            window.CountaboutPlugin.revertToBackupForID(dataSetID());
            yValueField().value = "OK";
            fetchAndConfigure();
            return;
        }
    }
            
    if ( newYValueString == "register" )
    {
        if ( window.widget )
        {
            window.CountaboutPlugin.licenseChanged();
            yValueField().value = "OK";
            return;
        }
    }
    
    if ( newYValueString == "t" )
    {
        if ( window.widget )
        {
            incrementDate(0);
            return;
        }
    }
    
    if ( newYValueString == "reset" )
    {
        if ( window.widget )
        {
            yValueField().value = "";
            showClearAllDialog();
            return;
        }
    }
    
    if ( newYValueString == "r" )
    {
        createReport();
    }
    
    if ( !Utilities.isValidDateString(newDateString) )
    {
        showDialog("", "Can't determine date.", "Use format MM/DD/YY");
        dateField().value = Utilities.formattedDateString(Utilities.daysAgoUTC(0));
        return;
    }
    // check to see if data already exists for date
    var aUTCDate = Utilities.UTCDateFromValidatedString(newDateString);
    //alert("date in field: " + Utilities.formattedDateString(aUTCDate, 1));
 
    var newYValueDescrip = null;
    var xValue = Utilities.numDaysSinceEpoch(aUTCDate);
    var aPoint = countaboutData.trackerData[selectedTrackerIndex].dataSet.pointForX(xValue);
    if ( aPoint == null )
    {
        newYValue = determineValueFromString(newYValueString);
        
        if ( newYValue == null )
        {
            showDialog("","Not a valid value.", "");
            //yValueField().value = newYValueString;
            return;
        }
        
        if ( newYValue.toString() != newYValueString )  // if transformed, will display original string
            newYValueDescrip = newYValueString;
        
        //alert("dataFieldChanged: adding point: " + xValue + " yValue: " + newYValue + " newDateString: " + newDateString + " UTC: " + aUTCDate);
        aPoint = new DataPoint();
        aPoint.setValues(xValue, newYValue, Utilities.formattedDateString(aUTCDate), newYValueDescrip);
        countaboutData.trackerData[selectedTrackerIndex].dataSet.points.push(aPoint);
        countaboutData.trackerData[selectedTrackerIndex].dataSet.sort();
    }
    else
    {
        if ( newYValueString == "x" || newYValueString == "X" )
        {
            var aDConfig = new DialogConfig();
            aDConfig.messageText = "Remove the value for " + newDateString + "?";
            aDConfig.rightButtonLabel = "Yes";
            aDConfig.middleButtonLabel = "No";
            aDConfig.rightCallback = removeCurrentPoint;
            aDConfig.middleCallback = keepCurrentPoint;
            showDialogWithConfig(aDConfig);
        }
        else  // handle as a value
        {
            newYValue = determineValueFromString(newYValueString);
            
            if ( newYValue == null )
            {
                showDialog("","Not a valid number.", "");
                yValueField().value = 0;
                return;
            }
            
            if ( newYValue.toString() != newYValueString )  // if transformed, will display original string
                newYValueDescrip = newYValueString;
                        
            if ( countaboutData.trackerData[selectedTrackerIndex].additionMode == "add" )
            {
                aPoint.setValues(xValue, aPoint.yValue + newYValue, Utilities.formattedDateString(aUTCDate), newYValueDescrip);
            }
            else
            {
                aPoint.setValues(xValue, newYValue, Utilities.formattedDateString(aUTCDate), newYValueDescrip);
            }
        }
    }
    
    save();
    Scale.current.adjustMinMax(countaboutData.trackerData[selectedTrackerIndex].dataSet.points, selectedTrackerIndex);
    barChart.setNeedsRefresh(true);
    drawBarChart();
    updateDailyTotal();
    updateStatistics();
    // scrollToXValue(xValue);
    if ( xValue > barChart.currentMaxX ) 
        scrollTo = "right";
    else if ( xValue < barChart.currentMinX )
        scrollTo = "left";
    else
        scrollTo = xValue;
    
    document.getElementById("lastEntryBox").innerText = "last entry: " + Utilities.formattedDateString(null, 1);
}

function determineValueFromString(aValueString)
{
    if ( aValueString == null ) return null;
    
    if ( aValueString.indexOf(":") == -1 )
    {
        if ( !numberRegExp.test(aValueString) ) return null;
        
        return parseFloat(aValueString);
    }

    var timeComponents = aValueString.split(':');
    for ( var iC = 0; iC < timeComponents.length; iC++ )
    {
        if ( timeComponents[iC].length == 0 ) continue;
        
        if ( !numberRegExp.test(timeComponents[iC]) ) return null;

        compValue = parseFloat(timeComponents[iC]);
        
        if ( isNaN(compValue) ) return null;

        if ( timeComponents.length == 1 )
        {
            newYValue = compValue;
        }
        else if ( timeComponents.length == 2 )
        {
            if ( iC == 0 )
                newYValue = compValue * 60.0;  // minutes
            else if ( iC == 1 )
                newYValue += compValue;  // seconds
        }
        else if ( timeComponents.length == 3 )
        {
            if ( iC == 0 )
                newYValue = compValue * 60.0 * 60.0;  // hours
            else if ( iC == 1 )
                newYValue += compValue * 60.0;  // minutes
            else if ( iC == 2 )
                newYValue += compValue;  // seconds
        }
        else if ( timeComponents.length == 4 )
        {
            if ( iC == 0 )
                newValue = compValue * 60.0 * 60.0 * 24.0;  // days
            else if ( iC == 1 )
                newYValue += compValue * 60.0 * 60.0;  // hours
            else if ( iC == 2 )
                newYValue += compValue * 60.0;  // minutes
            else if ( iC == 3 )
                newYValue += compValue;  // seconds
        }
        else
        {
            // showDialog("","Unsupported time format", "");
            return null;
        }
    }
    
    return newYValue;
}

function createReport(event)
{
    alert("createReport for ID: " + dataSetID() );
    if ( window.widget && dataSetID() != null )
    {
        window.CountaboutPlugin.createReportForID(dataSetID());
        return;
    }
}

function showReport(aURL)
{
    if ( window.widget )
        widget.openURL(aURL);
    
}

function annotate()
{
    document.getElementById('titlePopupMenu').disabled = "disabled";
    document.getElementById('flip').style.display = 'none';
	document.getElementById('modalFrontOverlay').style.display = "block";
    document.getElementById("noteEditor").style.display = "block";
    
    var aPoint = getCurrentPoint();
    if ( aPoint != null )
        document.getElementById("noteTextArea").innerText = aPoint.note;
    else
        document.getElementById("noteTextArea").innerText = "";
    
    document.getElementById("noteTextArea").focus();
}

function closeNotepad(event)
{
    var newValue = noteTextArea.value;
    var aPoint = getCurrentPoint();
    
    if ( newValue.indexOf(']]>') != -1)
    {
        showDialog("", "Can't store annotation.");
        newValue = aPoint ? aPoint.note : null;
    }
    
    if ( aPoint == null && newValue != null && newValue != "" )
    {
        aPoint = new DataPoint();
        countaboutData.trackerData[selectedTrackerIndex].dataSet.points.push(aPoint);
        var dateString = dateField().value;
        var aUTCDate = Utilities.UTCDateFromValidatedString(dateString);
        var xValue = Utilities.numDaysSinceEpoch(aUTCDate);
        aPoint.setValues(xValue, null, Utilities.formattedDateString(aUTCDate), null);
    }
    
    if ( aPoint != null && aPoint.note != newValue )
    {
        aPoint.note = noteTextArea.value;
        save();
    }
    
    document.getElementById("noteTextArea").innerText = "";
    document.getElementById("noteEditor").style.display = "none";
    document.getElementById('titlePopupMenu').disabled = false;
    document.getElementById('flip').style.display = "block";
    document.getElementById('modalFrontOverlay').style.display = "none";
    document.getElementById('chartNote').innerText = newValue;
    if ( newValue != null && newValue != "") document.getElementById('pencil').style.display = "block";
    
}

function exportToCSV()
{
    alert("exportToCSVForID: " + dataSetID() );
    if ( window.widget && dataSetID() != null )
    {
        window.CountaboutPlugin.exportCSVForID(dataSetID());
        return;
    }
}

function scrollToXValue(xValue)
{
    if ( !leftSideIsOpen ) return;
    
    if ( !xValue ) xValue = barChart.currentMaxX; // getTodaysXValue();
    
    var scrollPos = parseInt(barChart.width * pctOfXScale(xValue));
    
    var offset = barChart.currentNumBuckets > 1 ? barChart.width / barChart.currentNumBuckets : 0;
    
    chartScrollArea.horizontalScrollTo(scrollPos - offset );
    chartScrollbar.refresh();
    scrollTo = null;
}

function pctOfXScale(xValue)
{
    if ( barChart.currentMaxX == barChart.currentMinX ) return 0.0;
    
    var pct = (xValue - barChart.currentMinX) / (barChart.currentMaxX - barChart.currentMinX);
    
    //alert("pctOfXScale: " + pct);
    
    return pct;
}

function getCurrentXValue()
{
    var dateString = dateField().value;
    var aUTCDate = Utilities.UTCDateFromValidatedString(dateString);
    return Utilities.numDaysSinceEpoch(aUTCDate);
}

function getCurrentPoint()
{
    var xValue = getCurrentXValue();
    return countaboutData.trackerData[selectedTrackerIndex].dataSet.pointForX(xValue);
}

/* This should only be called when there is a known valid date in the dateField.  This is normally
 * called as a callback to a remove point dialog. */
function removeCurrentPoint()
{
    var dateString = dateField().value;
    var aUTCDate = Utilities.UTCDateFromValidatedString(dateString);
    var xValue = Utilities.numDaysSinceEpoch(aUTCDate);
    var aPoint = countaboutData.trackerData[selectedTrackerIndex].dataSet.pointForX(xValue);
    countaboutData.trackerData[selectedTrackerIndex].dataSet.removePoint(aPoint);
    yValueField().value = "";
    save();
    barChart.setData(countaboutData.trackerData[selectedTrackerIndex].dataSet.points, selectedTrackerIndex);
    //Scale.current.adjustMinMax(countaboutData.trackerData[selectedTrackerIndex].dataSet.points, selectedTrackerIndex);
    drawBarChart();
    updateDailyTotal();
    updateStatistics();
    showDialog("", "The value for " + dateString + " has been removed.");
}

function keepCurrentPoint()
{
    var dateString = dateField().value;
    var aUTCDate = Utilities.UTCDateFromValidatedString(dateString);
    var xValue = Utilities.numDaysSinceEpoch(aUTCDate);
    var aPoint = countaboutData.trackerData[selectedTrackerIndex].dataSet.pointForX(xValue);
    yValueField().value = aPoint.yValue;
}

function updateStatistics()
{
    var scale = Scale.directory[selectedScaleKey];
    var currentDataSet = countaboutData.trackerData[selectedTrackerIndex].dataSet;
    var stringedArray = countaboutData.trackerData[selectedTrackerIndex].statsEnabled.join();
    for ( i = 0; i < statsAll.length; i++ )
    {
        var show = stringedArray.indexOf(statsAll[i]) != -1;
        document.getElementById(statsAll[i] + "Row").style.display = show ? "table-row" : "none";
        
        if ( statsAll[i] == "statAvg" ) 
        {
            document.getElementById("statAvg").innerText = formattedYValue(currentDataSet.averageForRange(scale.getXMin(selectedTrackerIndex), scale.getXMax(selectedTrackerIndex)));
        }
        else if ( statsAll[i] == "statMax" )
        {
            document.getElementById("statMax").innerText = formattedYValue(currentDataSet.maxInRange(scale.getXMin(selectedTrackerIndex), scale.getXMax(selectedTrackerIndex)));
        }
        else if ( statsAll[i] == "statMin" )
        {
            document.getElementById("statMin").innerText = formattedYValue(currentDataSet.minInRange(scale.getXMin(selectedTrackerIndex), scale.getXMax(selectedTrackerIndex)));
        }
        else if ( statsAll[i] == "statDiff" )
        {
            document.getElementById("statDiff").innerText = formattedYValue(currentDataSet.differenceForRange(scale.getXMin(selectedTrackerIndex), scale.getXMax(selectedTrackerIndex)));
        }
        else if ( statsAll[i] == "statTotal" )
        {
            document.getElementById("statTotal").innerText = formattedYValue(currentDataSet.totalForRange(scale.getXMin(selectedTrackerIndex), scale.getXMax(selectedTrackerIndex)));
        }
        else if ( statsAll[i] == "statMedian" )
        {
            document.getElementById("statMedian").innerText = formattedYValue(currentDataSet.medianForRange(scale.getXMin(selectedTrackerIndex), scale.getXMax(selectedTrackerIndex)));
        }
        else if ( statsAll[i] == "statTarget")
        {
            document.getElementById("statTarget").innerText = formattedYValue(countaboutData.trackerData[selectedTrackerIndex].chart.goal);
        }
    }
}

function formattedYValue(value)
{
    if ( value == null || isNaN(value) ) return "";
    
    if ( countaboutData.trackerData[selectedTrackerIndex].dataSet.isTimeData() )
        return secondsToTimeString(value);
    else if ( countaboutData.trackerData[selectedTrackerIndex].units &&
        countaboutData.trackerData[selectedTrackerIndex].units.indexOf("$") >= 0 )
        value = parseFloat(value).toFixed(2);
    else
        value = Utilities.toFixedStripped(parseFloat(value), 2);
    
    return isNaN(value) ? "" : value;
}

function secondsToTimeString(value)
{
    var days = null;
    var hours = null;
    var minutes = null;
    var seconds = null;
    
    var aValue = value;
    if ( aValue > (3600 * 24.0) ) // days?
    {
        days = Math.floor(aValue / (3600 * 24));
        aValue = Math.floor(aValue) % (3600 * 24);
    }
    
    if ( aValue > 3600.0 ) // hours?
    {
        hours = Math.floor(aValue / 3600);
        aValue = Math.floor(aValue) % 3600;
    }
    //else
    //    hours = 0;
    
    if ( aValue > 60.0 ) // minutes?
    {
        minutes = Math.floor(aValue / 60);
        aValue = Math.floor(aValue) % 60.0;
    }
    else
        minutes = 0;
    
    seconds = Math.floor(aValue);
    
    var resultStr = "";
    if ( days != null ) 
    {
        //if ( days < 10 ) resultStr += "0";
        resultStr = days.toString() + ":";
    }
    
    if ( hours != null ) 
    {
        if ( hours < 10 && days != null ) resultStr += "0";
        resultStr = hours.toString() + ":";
    }
    
    if ( minutes != null )
    {
        if ( minutes < 10 && hours != null ) resultStr += "0";
        resultStr += minutes.toString() + ":";
    }
    
    if ( seconds < 10 && minutes != null) resultStr += "0";
    resultStr += seconds.toString();
    
    return resultStr;
}

function refreshDate()
{
    Scale.directory[SCALE_1_WEEK_KEY].setXMin(Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(6)));
    Scale.directory[SCALE_1_MONTH_KEY].setXMin(Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(31)));
    Scale.directory[SCALE_3_MONTH_KEY].setXMin(Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(92)));
    Scale.directory[SCALE_6_MONTH_KEY].setXMin(Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(6*30)));
    Scale.directory[SCALE_MTD_KEY].setXMin(Utilities.numDaysSinceEpoch(Utilities.beginningOfMonthUTC())+1);
    Scale.directory[SCALE_MTD_KEY].setNumBuckets((new Date).getDate());
    Scale.directory[SCALE_YTD_KEY].setXMin(Utilities.numDaysSinceEpoch(Utilities.beginningOfYearUTC()));
    Scale.directory[SCALE_YTD_KEY].setNumBuckets(Utilities.dayOfYear());
    Scale.directory[SCALE_1_YEAR_KEY].setXMin(Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(365)));
    
    var currentDaysSinceEpoch = Utilities.numDaysSinceEpoch();
    for ( var i = 0; i < Scale.list.length; i++ )
    {
        Scale.list[i].setXMax(currentDaysSinceEpoch);
    }
    
}


var lastEventTime = 0;
/*
 *     The only time we validate and add new data is when the user hits enter or
 *     return while in the x or y value fields.
 */
function dataFieldKeyPress(event)
{
    //alert("event.keyCode:" + event.keyCode);
    
    // receiving keystrokes, require a delay
    var timeNow = (new Date).getTime();                
    if ( timeNow - lastEventTime < 100 )
    {
        event.stopPropagation();
        return;
    }
    
    switch (event.keyCode)
    {
        case 13: // return
        case 3:  // enter
            if ( showingDialog && timeNow - lastEventTime > 500 )
            {
                clickOnDialogRightButton();
            }
            else if ( event.target.id == "dateField" || event.target.id == "yValueField" )
            {
                dataFieldChanged();
            }
            break;
            
            case 9:     // tab
            
            // move focus between data entry fields
            if ( event.target.id == "yValueField")
            {
                dateField().focus();
                dateField().setSelectionRange(0, 30);
            }
            else // if ( event.target.id == "dateField" )
            {
                focusAndSelect();
            }
            
            event.stopPropagation();
            break;
            
            case 95: // shift "-"
            case 63233: // down arrow
            if ( event.target.id == "dateField" )
                incrementDate(-1);
            else if ( event.target.id == "yValueField" )
                incrementYValue(-1);
            
            event.stopPropagation();
            break;
            
            case 43: // "+"
            case 63232: // up arrow
            
            if ( event.target.id == "dateField" )
                incrementDate(1);
            else if ( event.target.id == "yValueField" )
                incrementYValue(1);
            
            event.stopPropagation();
            break;
            
            case 63235: // right arrow
            if ( event.shiftKey )
            {
                incrementDate(1);
                event.stopPropagation();
            }
            break;
            
            case 63234: // left arrow
            if ( event.shiftKey )
            {
                incrementDate(-1);
                event.stopPropagation();
            }
            break;
            
            case 33: // shift-1 (!)
            changeSelectedTrackerToIndex(0, event);                
            event.stopPropagation();
            break;
            
            case 64: // shift-2 (@)
            changeSelectedTrackerToIndex(1, event);                
            event.stopPropagation();
            break;
            
            case 35: // shift-3 (#)
            changeSelectedTrackerToIndex(2, event);                
            event.stopPropagation();
            break;
            
            // toggle drawers on 'o'pen or 'c'lose
            case 111: // o
            case 79: // O
            if ( rightSideIsOpen && !leftSideIsOpen )
            {
                toggleLeftTray(event);
            }
            else if ( leftSideIsOpen && !rightSideIsOpen )
            {
                toggleRightTray(event);
            }
            else
            {
                pendingRightSideToggle = true;
                toggleLeftTray(event);
            }
            event.preventDefault();
            event.stopPropagation();
            break;
            
            case 99: // c
            case 67: // C
            if ( rightSideIsOpen && !leftSideIsOpen )
            {
                toggleRightTray(event);
            }
            else if ( leftSideIsOpen && !rightSideIsOpen )
            {
                toggleLeftTray(event);
            }
            else
            {
                pendingRightSideToggle = true;
                toggleLeftTray(event);
            }
            event.preventDefault();
            event.stopPropagation();
            break;
    }
    
    lastEventTime = timeNow;
    
}

function incrementDate(deltaDays)
{
    if ( upgradeDisabled ) 
    {
        upgradeDisabledLatch = false;
        showCloseForUpgradeDialog();
        return;
    }
    
    var newDateString = "";
    
    if ( deltaDays == null ) deltaDays = 0;
    
    if ( deltaDays == 0 )
    {
        newDateString = Utilities.formattedDateString(Utilities.daysAgoUTC(0));
        currentXValue = Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(0));
    }
    else
    {
        // "current" date means date entered in textfield, not today's date
        var currentDateString = dateField().value;
        //alert("parsed date: " + Utilities.UTCDateFromValidatedString(currentDateString) + " daysAgoUTC(0): " + Utilities.daysAgoUTC(0) );
        var currentDateUTC = Utilities.isValidDateString(currentDateString) ? Utilities.UTCDateFromValidatedString(currentDateString) : Utilities.daysAgoUTC(0);
        currentXValue = Utilities.numDaysSinceEpoch(currentDateUTC) + deltaDays;
        
        newDateString = Utilities.formattedDateString(currentDateUTC + (deltaDays * Utilities.MILLISECS_PER_DAY));
    }
    
    //var convertedDate = Utilities.numDaysSinceEpoch(newDate);
    //alert("incrementDate: currentXValue: " + currentXValue + " deltaDays: " + deltaDays);
    
    var pointForDate = null;
    if ( countaboutData && countaboutData.trackerData.length > 0 && countaboutData.trackerData[selectedTrackerIndex].dataSet )
        pointForDate = countaboutData.trackerData[selectedTrackerIndex].dataSet.pointForX(currentXValue);
    
    //var yValueForDate = (pointForDate == null ) ? "" : pointForDate.yValue;
    //yValueField().value = (yValueForDate == null || isNaN(yValueForDate)) ? "" : yValueForDate + "";
    yValueField().value = valueStringForPoint(pointForDate);
    
    dateField().value = newDateString;
    focusAndSelect();
    
    scrollToXValue(currentXValue);
    if ( pointForDate && pointForDate.note && pointForDate.note != "")
    {
        document.getElementById("chartNote").innerText = pointForDate.note;
        document.getElementById('pencil').style.display = "block";
    }
    else
    {
        document.getElementById("chartNote").innerText = "";
        document.getElementById('pencil').style.display = "none";
    }
}

function focusAndSelect()
{
    if ( upgradeDisabled ) 
    {
        yValueField().blur();
        showCloseForUpgradeDialog();
        return;
    }
    
    yValueField().focus();
    yValueField().setSelectionRange(0, 30);
}

function updateDailyTotal()
{
    var todaysTotal = dailyTotal();
    
    if ( countaboutData.trackerData[selectedTrackerIndex].additionMode == "add" )
        document.getElementById("dailyTotalLabel").innerText = "Today's Total: " + todaysTotal;
    else
        document.getElementById("dailyTotalLabel").innerText = "Today: " + todaysTotal;  
}

function clearDailyTotal()
{
    document.getElementById("dailyTotalLabel").innerText = "";
}

function incrementYValue(delta)
{
    if ( delta == null ) delta = 1;
    
    var currentValue = yValueField().value;
    if ( currentValue == "" || isNaN(currentValue) ) 
        currentValue = 0;
    else
        currentValue = parseFloat(currentValue);
    
    yValueField().value = currentValue + delta;
    yValueField().setSelectionRange(0,30);
    
}

function dateField()
{
    return document.getElementById("dateField");
}

function yValueField()
{
    return document.getElementById("yValueField");
}

function prefixUnitsLabelClicked(event)
{
    prefixUnitsChanged(event);
}

function prefixUnitsChanged(event)
{
    var element = document.getElementById('prefixUnitsCheckDiv');
    
    element.checked = !element.checked;
    
    countaboutData.trackerData[selectedTrackerIndex].prefixUnits = element.checked;
}

function positionUnits()
{
    var dataEntryElement = document.getElementById("dataEntry");
    var unitsLabelElement = document.getElementById("unitsLabel");
    var yValueFieldWrapperElement = document.getElementById("yValueFieldWrapper");
    var yValueFieldElement = document.getElementById("yValueField");
    
    if ( countaboutData.trackerData[selectedTrackerIndex].prefixUnits )
    {
        dataEntryElement.removeChild(unitsLabelElement);
        dataEntryElement.insertBefore(unitsLabelElement, yValueFieldWrapperElement);
        unitsLabelElement.style["text-align"] = "right";
        unitsLabelElement.style["margin-left"] = "4px";
        unitsLabelElement.style["width"] = 10 * countaboutData.trackerData[selectedTrackerIndex].units.length + "px";
    }
    else
    {
        dataEntryElement.removeChild(yValueFieldWrapperElement);
        dataEntryElement.insertBefore(yValueFieldWrapperElement, unitsLabelElement);
        unitsLabelElement.style["text-align"] = "left";
        unitsLabelElement.style["width"] = "63px";
    }
}

function additionModeLabelClicked(event)
{
    additionModeChanged(event);
    focusAndSelect();
}

function additionModeChanged(event)
{
    var element = document.getElementById('additionModeCheckDiv');
    
    element.checked = !element.checked;
    
    if ( element.checked ) 
        countaboutData.trackerData[selectedTrackerIndex].additionMode = "add";
    else
        countaboutData.trackerData[selectedTrackerIndex].additionMode = "replace";
}

function createkey(key)
{
    return widget.identifier + "-" + key;
}

function firstLoad()
{
    preloadSetup();
}

function preloadSetup()
{
    countaboutStyle = new CountaboutStyle();
    
    document.getElementById("versionBox").innerText = "v" + getVersionString();
    
    document.getElementById("releaseButtonLeftImg").src = "styles/" + countaboutStyle.key + "/images/trayReleaseButton.png";
    document.getElementById("releaseButtonRightImg").src = "styles/" + countaboutStyle.key + "/images/trayReleaseButton.png";
    document.getElementById("decButtonImg").src = "styles/" + countaboutStyle.key + "/images/arrowLeft.png";
    document.getElementById("todayButtonImg").src = "styles/" + countaboutStyle.key + "/images/arrowCenter.png";
    document.getElementById("incButtonImg").src = "styles/" + countaboutStyle.key + "/images/arrowRight.png";
    
    setTitle("Countabout");
    
  	if ( window.widget != null ) widget.setCloseBoxOffset(231, 3);
  	
    if ( window.widget )
    {
        if ( window.CountaboutPlugin.setWidgetType != null)
          window.CountaboutPlugin.setWidgetType(getWidgetType());
        window.CountaboutPlugin.install(dataSetID());
    }
    
    var pref;
    
    todaysDate = Utilities.daysAgoUTC(0);
    
    setTitle('Loading...');
    
    var currentDaysSinceEpoch = Utilities.numDaysSinceEpoch();
    
    var aScale = new Scale(SCALE_1_WEEK_KEY, "1 week");
    aScale.setNumBuckets(7);
    aScale.setXMin(Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(6)));
    aScale.setXMax(currentDaysSinceEpoch);
    
    aScale = new Scale(SCALE_1_MONTH_KEY, "1 mnth");
    aScale.setNumBuckets(30);
    aScale.setXMin(Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(30)));
    aScale.setXMax(currentDaysSinceEpoch);
    
    aScale = new Scale(SCALE_3_MONTH_KEY, "3 mnth");
    aScale.setNumBuckets(92);
    aScale.setXMin(Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(92)));
    aScale.setXMax(currentDaysSinceEpoch);
    
    aScale = new Scale(SCALE_6_MONTH_KEY, "6 mnth");
    aScale.setNumBuckets(6*30);
    aScale.setXMin(Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(6*30)));
    aScale.setXMax(currentDaysSinceEpoch);
    
    aScale = new Scale(SCALE_MTD_KEY, "  MTD");
    aScale.setNumBuckets((new Date).getDate());
    aScale.setXMin(Utilities.numDaysSinceEpoch(Utilities.beginningOfMonthUTC())+1);
    aScale.setXMax(currentDaysSinceEpoch);
    
    aScale = new Scale(SCALE_YTD_KEY, "  YTD");
    aScale.setNumBuckets(Utilities.dayOfYear());
    aScale.setXMin(Utilities.numDaysSinceEpoch(Utilities.beginningOfYearUTC()));
    aScale.setXMax(currentDaysSinceEpoch);
    
    aScale = new Scale(SCALE_1_YEAR_KEY, "1 year");
    aScale.setNumBuckets(365);
    aScale.setXMin(Utilities.numDaysSinceEpoch(Utilities.daysAgoUTC(365)));
    aScale.setXMax(currentDaysSinceEpoch);
    
    aScale = new Scale(SCALE_AUTO_KEY);
    Scale.current = Scale.directory[SCALE_AUTO_KEY];
    
    if (window.widget)
    {
        pref = widget.preferenceForKey(createkey("scale"));
        selectedScaleKey = ( pref == null) ? SCALE_1_WEEK_KEY : pref;
    }
    else
        selectedScaleKey = SCALE_1_WEEK_KEY;
    
    Scale.current = Scale.directory[selectedScaleKey];
    
	var modalFrontRightButton = document.getElementById('modalFrontRightButton');
	createButton(modalFrontRightButton, getLocalizedString('OK'), clickOnDialogRightButton, 66, "modalFrontRightButtonID");
    
	var modalFrontMiddleButton = document.getElementById('modalFrontMiddleButton');
	createButton(modalFrontMiddleButton, getLocalizedString('No'), clickOnDialogMiddleButton, 66, "modalFrontMiddleButtonID");
    
	var modalFrontLeftButton = document.getElementById('modalFrontLeftButton');
	createButton(modalFrontLeftButton, getLocalizedString('Cancel'), clickOnDialogLeftButton, 66, "modalFrontLeftButtonID");
    
	var modalRightButton = document.getElementById('modalRightButton');
	createButton(modalRightButton, getLocalizedString('OK'), clickOnDialogRightButton, 66, "modalRightButtonID");
	
	var modalMiddleButton = document.getElementById('modalMiddleButton');
	createButton(modalMiddleButton, getLocalizedString('No'), clickOnDialogMiddleButton, 66, "modalMiddleButtonID");
    
	var modalLeftButton = document.getElementById('modalLeftButton');
	createButton(modalLeftButton, getLocalizedString('Cancel'), clickOnDialogLeftButton, 66, "modalLeftButtonID");
    
    createGenericButton(document.getElementById('done'), 'Done', backSideDismissed);
    createGenericButton(document.getElementById('checkForUpdates'), 'Check for Updates', checkForUpdates);
    createGenericButton(document.getElementById('dataSetNewButtonDiv'), 'New', newDataSet, 57);
    //createGenericButton(document.getElementById('applyStyle'), 'Apply', applyStyle);
    //createGenericButton(document.getElementById('fetchStyle'), 'Download and Apply', fetchAndApplyStyle);
    
    
    chartScrollbar = new AppleHorizontalScrollbar(document.getElementById("chartScrollbar"));
    chartScrollArea = new AppleScrollArea(document.getElementById("chartScrollArea"));
    chartScrollArea.addScrollbar(chartScrollbar);
    
	this.fetchAndConfigure();
	
	barChart.draw();
	
	// having a problem getting the tray to be enabled, this gives it a nudge
    toggleRightTray();
    toggleRightTray();
    toggleLeftTray();
    toggleLeftTray();
    
}

function formatYValueString(value)
{
    var units = countaboutData.trackerData[selectedTrackerIndex].units;
    if ( value == null || isNaN(value) ) return "";
    
    if ( units && units.indexOf("$") >= 0 )
        value = parseFloat(value).toFixed(2);
    else
        value = Utilities.toFixedStripped(parseFloat(value), 2);
    
    var isSingular = ( !isNaN(value) && value == 1 );
    var cvtdUnits = isSingular ? singularize(units) : units;
    
    if ( cvtdUnits == null || cvtdUnits == "null") cvtdUnits = "";
    
    return countaboutData.trackerData[selectedTrackerIndex].prefixUnits ? "" + cvtdUnits + value : "" + value + " " + cvtdUnits;
}

function singularize(unitsString)
{
    if ( !unitsString ) return "";
    
    var iesIndex = unitsString.lastIndexOf("ies");
    
    if ( iesIndex == unitsString.length - 3 )
        return unitsString.substring(0,iesIndex) + "y";
    
    var sIndex = unitsString.lastIndexOf("s");
    if ( sIndex == unitsString.length - 1 )
        return unitsString.substring(0,sIndex);
    
    return unitsString;
}

function barClickCallback(event)
{
    var anIndex = event.target.id;
    var xValue = "";
    var yValue = "";
    var note = "";
    
    var pointForIndex = countaboutData.trackerData[selectedTrackerIndex].dataSet.points[anIndex];
    if ( pointForIndex )
    {
        xValue = pointForIndex.xDescription;
        yValue = pointForIndex.yDescription == null ? pointForIndex.yValue : pointForIndex.yDescription;
        note = pointForIndex.note;
    }
    
    yValueField().value = yValue;
    dateField().value = xValue;
    
    if ( document.getElementById("chartNote") != null && document.getElementById("noteTextArea") != null )
    {
		document.getElementById("chartNote").innerText = note;
		document.getElementById("noteTextArea").innerText = note;
		
		if ( !note || note == "")
			document.getElementById('pencil').style.display = "none";
		else
		{
			document.getElementById("chartNote").style.display = "block";
			document.getElementById('pencil').style.display = "block";
		}
    }
    
    focusAndSelect();
}

function barMouseOverCallback(event)
{
    var anIndex = event.target.id;
    var xValue = "";
    var yValue = "";
    var note = "";
    
    var pointForIndex = countaboutData.trackerData[selectedTrackerIndex].dataSet.points[anIndex];
    if ( pointForIndex )
    {
        xValue = pointForIndex.xDescription;
        yValue = pointForIndex.yDescription == null ? pointForIndex.yValue : pointForIndex.yDescription;
        note = pointForIndex.note;
    }
    
    document.getElementById("hoverDate").innerText = xValue;
    document.getElementById("hoverValue").innerText = yValue;
    document.getElementById("hoverDate").style.display = "block";
    document.getElementById("hoverValue").style.display = "block";
    
    if ( !note || note == "")
        document.getElementById('hoverNote').style.display = "none";
    else
        document.getElementById("hoverNote").style.display = "block";
    
}

function barMouseOutCallback(event)
{
    document.getElementById("hoverDate").style.display = "none";
    document.getElementById("hoverValue").style.display = "none";
    document.getElementById("hoverNote").style.display = "none";
}

function fetchAndConfigure()
{
    alert("fetchAndConfigure... " + dataSetID());
    fetchData();
    
    if ( countaboutData.trackerData[selectedTrackerIndex].title == null ||
        countaboutData.trackerData[selectedTrackerIndex].title == "undefined" )
    {
        countaboutData.trackerData[selectedTrackerIndex].title = DEFAULT_TITLE;
    }
    
    for ( i = 0; i < countaboutData.trackerData.length; i++)
    {
        // replace with actual
        settingTitles[i] = countaboutData.trackerData[i].title;
    }
    populateTitleSelect();
    populateSettingSelection();
    //populateStyleSelect();
    
    refreshSettingPanel();
    
    barChart = new BarChart(CANVAS_WIDTH, CANVAS_HEIGHT, CHART_HEIGHT);
    for ( indexr = 0; indexr < countaboutData.trackerData.length; indexr++)
    {
        Scale.current.adjustMinMax(countaboutData.trackerData[indexr].dataSet.points, indexr);
        barChart.setData(countaboutData.trackerData[indexr].dataSet.points, indexr);
        barChart.setChartConfig(countaboutData.trackerData[indexr].chart, indexr);
        if ( countaboutData.trackerData[indexr].chart.enabled )
            document.getElementById("bullet" + indexr).src = "images/bulletFilled33Pct.png";
        else
            document.getElementById("bullet" + indexr).src = "images/bullet33Pct.png";
        
    }
    
    chartScrollArea.refresh();
    
    if ( countaboutData.trackerData[selectedTrackerIndex].additionMode == null )
    {
        countaboutData.trackerData[selectedTrackerIndex].additionMode = "replace";
    }
    
    document.getElementById("modeIcon-img").src = countaboutData.trackerData[selectedTrackerIndex].additionMode == "add" ? 
    "styles/" + countaboutStyle.key + "/images/plusSignButton.png" : 
    "styles/" + countaboutStyle.key + "/images/equalSignButton.png";
    
    if ( countaboutData.trackerData[selectedTrackerIndex].units == null )
    {
        countaboutData.trackerData[selectedTrackerIndex].units = DEFAULT_UNITS;
    }
    
    if ( countaboutData.trackerData[selectedTrackerIndex].units == "null") countaboutData.trackerData[selectedTrackerIndex].units = "";
    
    document.getElementById("unitsLabel").innerText = countaboutData.trackerData[selectedTrackerIndex].units;
    barChart.setUnitsString(countaboutData.trackerData[selectedTrackerIndex].units, countaboutData.trackerData[selectedTrackerIndex].prefixUnits);
    positionUnits();
    
    populateScaleSelect();
    document.getElementById("scalePopupLabel").innerText = Scale.directory[selectedScaleKey].label;
    
    window.resizeTo(widgetWidth() + "px", widgetHeight() + "px");
    
    dateField().value = Utilities.formattedDateString();
    yValueField().value = dailyTotal();
    focusAndSelect();
    updateStatistics();
    
    drawBarChart();
    
  	document.getElementById("modalTitle").innerText = "";
  	document.getElementById("modalFrontTitle").innerText = "";
    
}



function backSideDismissed()
{
    showFront();
}

function checkForUpdates()
{
    alert("checkForUpdates...");
    
    if ( window.widget )
    {
        window.CountaboutPlugin.checkForUpdates();
    } 
}

function noUpdatesFound()
{
    showDialog("", "No updates were found.");
}

function updateAvailable(versionString)
{
    var aDConfig = new DialogConfig();
    aDConfig.messageText = "There is an update available (" + versionString + ") Would you like to install it?";
    aDConfig.rightButtonLabel = "Yes";
    aDConfig.middleButtonLabel = "No";
    aDConfig.rightCallback = installUpdateSelected;
    
    showDialogWithConfig(aDConfig);
}

function installUpdateSelected()
{
    if ( window.widget )
        window.CountaboutPlugin.applyLatestUpdate();
}

function upToDate()
{
    var aDConfig = new DialogConfig();
    aDConfig.messageText = "Your Countabouts are up-to-date.";
    aDConfig.rightButtonLabel = "OK";
    
    showDialogWithConfig(aDConfig);
}


function browseStyles()
{
    if (window.widget)
        widget.openURL("http://www.freshmowed.com/countabout/gallery.html");        
}

function applyStyle(selectedStyleKey)
{
    // var selectedStyleKey = styleKeys[document.getElementById('styleSelectionPopupMenu').selectedIndex];
    
    if ( window.widget )
    {
        window.CountaboutPlugin.switchToStyleWithKey(selectedStyleKey);
    } 
}

function fetchAndApplyStyle()
{
    var selectedStyleKey = document.getElementById('styleKeyField').value;
    
    if ( window.widget )
    {
        alert("fetchAndApplyStyle: " + selectedStyleKey);
        window.CountaboutPlugin.downloadAndSwitchToStyleWithKey(selectedStyleKey);
    }
}

function incompatibleStyle(styleKey)
{
    showDialog("","We're sorry, the style you selected (" + styleKey + ") is not compatible with your version.");
}

function showEULA()
{
    if ( window.widget ) 
        widget.openURL("http://www.freshmowed.com/FM_EULA_SnglMchn.html");
    
}

function populateRegistrationContents(theContents)
{
    var registrationDiv = document.getElementById('registration');
    var textNode = document.createTextNode(theContents);
    
    if ( registrationDiv == null )
        alert("did not get registration div");
    else
    {
        if ( oldRegistrationContentsDiv )
            registrationDiv.replaceChild(textNode, oldRegistrationContentsDiv);
        else
            registrationDiv.appendChild(textNode);
        
        oldRegistrationContentsDiv = textNode;
    }
}

function restoreArchivedData()
{
    alert("restoreArchivedData..." + currentDialogConfig.userInfo);
    if ( window.widget )
    {
        window.CountaboutPlugin.restoreDataFromID(currentDialogConfig.userInfo);
    }
}

function deleteArchivedData()
{
    alert("deleteArchivedData..." + currentDialogConfig.userInfo);
    if ( window.widget )
    {
        window.CountaboutPlugin.deleteDataForID(currentDialogConfig.userInfo);
    }
}

function showRestorePromptForID(aWidgetID, title)
{
    var aDConfig = new DialogConfig();
    if ( title)
        aDConfig.messageText = "There is archived data with a title of \"" + title + "\". Would you like to restore it?";
    else
        aDConfig.messageText = "There is archived data. Would you like to restore it?";
    
    aDConfig.rightButtonLabel = "Yes";
    aDConfig.middleButtonLabel = "Delete";
    aDConfig.leftButtonLabel = "Archive";
    aDConfig.rightCallback = restoreArchivedData;
    aDConfig.middleCallback = deleteArchivedData;
    
    aDConfig.userInfo = aWidgetID;
    
    showDialogWithConfig(aDConfig);
}

function showUpgradedDialog()
{
    showDialog("Countabout Upgraded", "This Countabout has been replaced by a newer version, please close this one.");
}

function showClearAllDialog()
{
    var aDConfig = new DialogConfig();
    aDConfig.messageText = "Are you sure you want to DELETE ALL data?";
    aDConfig.rightButtonLabel = "Yes";
    aDConfig.middleButtonLabel = "No";
    aDConfig.rightCallback = clearAllData;
    showDialogWithConfig(aDConfig);
}


function clearAllData()
{
    alert("clearAllData...");
    if ( window.widget )
    {
        window.CountaboutPlugin.deleteDataForID(dataSetID());
        fetchAndConfigure();
    }
}

function showUpgradeSucceededDialog(numToOpen, numToClose)
{
    var numToOpenAdj = numToOpen - 1;
    var numToCloseAdj = numToClose - 1;
    
    this.fetchAndConfigure();
    
    if ( numToOpenAdj <= 0 ) return;
    
    createMessage = "Please create " + numToOpenAdj  + " more Countabout widgets to complete upgrade.";
    
    var aDConfig = new DialogConfig();
    aDConfig.title = "Countabout Upgraded";
    aDConfig.messageText = createMessage;
    aDConfig.messageText2 = null;
    aDConfig.rightButtonLabel = "OK";
    showDialogWithConfig(aDConfig);    
}

function showUpgradeProcessDialog(numToOpen, numToClose)
{
    if ( numToOpen == 0 ) return;
    
    if ( numToOpen > 0 )
        showDialog("Countabout Upgraded", "Please create " + numToOpen + " more Countabout widgets to complete upgrade.");
    
    /*
     if ( numToOpen == 0 && numToClose == 0 ) return;
     
     if ( numToClose == 0 && numToOpen > 0 )
     showDialog("Countabout Upgraded", "Please create " + numToOpen + " more Countabout widgets to complete upgrade.");
     else if ( numToClose > 0 && numToOpen == 0 )
     showDialog("Countabout Upgraded", "Please close your old Countabouts (" + numToClose + ") to complete upgrade.");
     else
     showDialog("Countabout Upgraded", "Please close your old Countabouts (" + numToClose + "), and create " + numToOpen
     + " more to complete upgrade.");
     */
}

function showCloseForUpgradeDialog()
{
    makeDisabled();
    
    var aDConfig = new DialogConfig();
    aDConfig.messageText = "This Countabout has been upgraded.  Please Close.";
    aDConfig.rightButtonLabel = null;
    showDialogWithConfig(aDConfig);    
}

function makeDisabled()
{
    upgradeDisabled = true;
    
    if ( !showingFront )
    {
        var front = document.getElementById("outerContainer");
        var back = document.getElementById("back");
        
        if (window.widget)
            widget.prepareForTransition("ToFront");
        
        front.style.display="block";
        back.style.display="none";
        
        showingFront = true;
        
        if (window.widget)
            setTimeout ('widget.performTransition();', 0);
        
        window.resizeTo(widgetWidth() + "px", widgetHeight() + "px");
    }
    
    if ( rightSideIsOpen && !leftSideIsOpen )
    {
        toggleRightTray(event);
    }
    else if ( leftSideIsOpen && !rightSideIsOpen )
    {
        toggleLeftTray(event);
    }
    else if ( leftSideIsOpen && rightSideIsOpen )
    {
        pendingRightSideToggle = true;
        toggleLeftTray(event);
    }
    
    if ( bottomIsOpen ) toggleBottomTray(event);
    
    yValueField().enabled = false;
    dateField().enabled = false;
    document.getElementById('titlePopupMenu').disabled = "disabled";
    document.getElementById('fliprollie').style.display = 'none';
    document.getElementById('flip').style.display = 'none';
    document.getElementById('datePrefix').focus(); // something harmless
}

function showAppropriateDialog(messageTitle, messageText1, messageText2)
{
    showDialog(messageTitle, messageText1, messageText2);
}

function showDialog(messageTitle, messageText1, messageText2, rightButtonLabel, middleButtonLabel, leftButtonLabel, rightCallback, middleCallback, leftCallback)
{
    var aDConfig = new DialogConfig();
    aDConfig.title = messageTitle;
    if ( messageText1 == null || messageText1 == "" || messageText2 == null || messageText2 == "" )
    {
        aDConfig.messageText = ( messageText1 == null ? messageText2 : messageText1 );
        aDConfig.messageText1 = null;
        aDConfig.messageText2 = null;
    }
    else
    {
        aDConfig.messageText1 = messageText1;
        aDConfig.messageText2 = messageText2;
    }
    if ( rightButtonLabel ) aDConfig.rightButtonLabel = rightButtonLabel;
    aDConfig.middleButtonLabel = middleButtonLabel;
    aDConfig.leftButtonLabel = leftButtonLabel;
    aDConfig.rightCallback = rightCallback;
    aDConfig.middleCallback = middleCallback;
    aDConfig.leftCallback = leftCallback;
    
    showDialogWithConfig(aDConfig);
}

function showDialogWithConfig( aDialogConfig )
{
    if ( upgradeDisabledLatch ) return;
    
    if ( upgradeDisabled ) upgradeDisabledLatch = true;
    
    if ( showingDialog )
    {
        // queuedDialogs.push(aDialogConfig);
        //return;
        clearModalDialog();
    }
    
    showingDialog = true;
    currentDialogConfig = aDialogConfig;
    
    if ( showingFront )
    {  
      	if (aDialogConfig.rightButtonLabel != null )
      	{
      	    document.getElementById('modalFrontRightButton').setAttribute("style", "display:block;");
      	    document.getElementById('modalFrontRightButtonID').innerText = aDialogConfig.rightButtonLabel;
  	    }
      	else
            document.getElementById('modalFrontRightButton').setAttribute("style", "display:none;");
        
      	if (aDialogConfig.middleButtonLabel != null ) 
      	{
      	    document.getElementById('modalFrontMiddleButton').setAttribute("style", "display:block;");
            document.getElementById('modalFrontMiddleButtonID').innerText = aDialogConfig.middleButtonLabel;
      	}
      	else
            document.getElementById('modalFrontMiddleButton').setAttribute("style", "display:none;");
        
      	if (aDialogConfig.leftButtonLabel != null ) 
      	{
      	    document.getElementById('modalFrontLeftButton').setAttribute("style", "display:block;");
            document.getElementById('modalFrontLeftButtonID').innerText = aDialogConfig.leftButtonLabel;
  	    }
      	else
            document.getElementById('modalFrontLeftButton').setAttribute("style", "display:none;");
        
        document.getElementById('modalFrontTitle').innerText = aDialogConfig.title;
        
        document.getElementById("modalFrontMessage").innerText = "";
      	document.getElementById("modalFrontMessage1").innerText = "";
      	document.getElementById("modalFrontMessage2").innerText = "";
        
        if ( aDialogConfig.messageText != null && aDialogConfig.messageText != "")
        {
            document.getElementById("modalFrontMessage").innerText = aDialogConfig.messageText;
        }
        else if ( aDialogConfig.messageText1 == null || aDialogConfig.messageText1 == "" || aDialogConfig.messageText2 == null || aDialogConfig.messageText2 == "" )
        {
            document.getElementById("modalFrontMessage").innerText = ( (aDialogConfig.messageText1 == null || aDialogConfig.messageText1 == "") ? aDialogConfig.messageText2 : aDialogConfig.messageText1 );
        }
        else
        {
        	document.getElementById("modalFrontMessage1").innerText = aDialogConfig.messageText1;
        	document.getElementById("modalFrontMessage2").innerText = aDialogConfig.messageText2;
        }
        
      	document.getElementById('modalFrontDivContainer').setAttribute ("style", "display:block;");
      	document.getElementById('modalFrontOverlay').setAttribute ("style", "display:block;");
        
  	    document.getElementById('fliprollie').style.display = 'none';
        
        fadeElement = document.getElementById("modalFrontDivContainer");
    }
    else
    {
      	if (aDialogConfig.rightButtonLabel != null )
      	{
      	    document.getElementById('modalRightButton').setAttribute ("style", "display:block;");
      	    document.getElementById('modalRightButtonID').innerText = aDialogConfig.rightButtonLabel;
  	    }
      	else
            document.getElementById('modalRightButton').setAttribute ("style", "display:none;");
        
      	if (aDialogConfig.middleButtonLabel != null ) 
      	{
      	    document.getElementById('modalMiddleButton').setAttribute ("style", "display:block;");
            document.getElementById('modalMiddleButtonID').innerText = aDialogConfig.middleButtonLabel;
  	    }
      	else
            document.getElementById('modalMiddleButton').setAttribute ("style", "display:none;");
        
      	if (aDialogConfig.leftButtonLabel != null ) 
      	{
      	    document.getElementById('modalLeftButton').setAttribute ("style", "display:block;");
            document.getElementById('modalLeftButtonID').innerText = aDialogConfig.leftButtonLabel;
  	    }
      	else
            document.getElementById('modalLeftButton').setAttribute ("style", "display:none;");
        
      	document.getElementById("modalTitle").innerText = aDialogConfig.title;
      	document.getElementById("modalMessage").innerText = aDialogConfig.messageText;
      	document.getElementById("modalMessage1").innerText = aDialogConfig.messageText1;
      	document.getElementById("modalMessage2").innerText = aDialogConfig.messageText2;
        
      	document.getElementById('modalDivContainer').setAttribute ("style", "display:block;");
      	document.getElementById('modalOverlay').setAttribute ("style", "display:block;");
        
        fadeElement = document.getElementById("modalDivContainer");
    }
    
    fadeAnimation.startTime = (new Date).getTime() - 13; //! set it back one frame (critical).
    fadeAnimation.timer = setInterval("fadeIn();", 13);
    fadeAnimation.onfinished = null;
    fadeIn();
}


var widgetResizedForDialog = false;
var preDialogHeight;

function clearModalDialog()
{
	if ( showingFront )
	{
	    document.getElementById('modalFrontOverlay').style.display = 'none';
    }
	else
	{
	    document.getElementById('modalOverlay').style.display = 'none';
    }
    
	startFadeOut(modalFadeComplete);
}

function startFadeOut(callbackFunction)
{
    fadeOutAnimation.onfinished = callbackFunction;
    fadeOutAnimation.startTime = (new Date).getTime() - 13; //! set it back one frame (critical).
    fadeOutAnimation.timer = setInterval("fadeOut();", 13);
    fadeOut();
}

function modalFadeComplete()
{
    fadeOutAnimation.onfinished = null;
    
    if ( showingFront )
    {
        document.getElementById('modalFrontOverlay').style.display = 'none';
 	    document.getElementById('modalFrontDivContainer').style.display = 'none';
    }
  	else
  	{
	    document.getElementById('modalOverlay').style.display = 'none';
        document.getElementById('modalDivContainer').style.display = 'none';
    }
    
	showingDialog = false;
    
    if ( currentDialogConfig.callbackToPerform ) currentDialogConfig.callbackToPerform();
}

function clickOnDialogRightButton()
{
    currentDialogConfig.callbackToPerform = currentDialogConfig.rightCallback;
    clearModalDialog();
}

function clickOnDialogMiddleButton()
{
    currentDialogConfig.callbackToPerform = currentDialogConfig.middleCallback;
    clearModalDialog();
}

function clickOnDialogLeftButton()
{
    currentDialogConfig.callbackToPerform = currentDialogConfig.leftCallback;
    clearModalDialog();
}


if (window.widget)
{
    widget.onremove = onremove;
    widget.onhide = onhide;
    widget.onshow = onshow;
}

function onremove()
{
    if (window.widget)
    {
        widget.setPreferenceForKey(null, createkey("scale"));
        window.CountaboutPlugin.deinstall(widget.identifier);
    }
}

function onshow()
{
    //incrementDate(0);
    
    // if we're showing ourselves for the first time today, then reset to today's date,
    // and 
    if ( todaysDate != Utilities.daysAgoUTC(0) )
    {
        todaysDate = Utilities.daysAgoUTC(0);
        refreshDate();
        //if ( barChart) drawBarChart();
    }
    
    if ( dailyTotal() == null )
    {
        clearDailyTotal();
        document.getElementById("lastEntryBox").innerText = "hit return after entering new value";
    }
}

function onhide()
{
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}

